<?php
/*******************************************************************************
 *	BCommon.php		General routines
 *	Copyright		Terry Barnaby,	BeamWeb,	2008-01-06
 *******************************************************************************
 */
require_once "BHtml.php";

function array_value_exists($value, $array){
	$array = array_flip($array);

	return array_key_exists($value, $array);
}

function dateString($date){
	if($date == "")
		return "";
	else
		return date_format(new DateTime($date), "d/m/Y");
}

function dateTimeString($date){
	if($date == "")
		return "";
	else
		return date_format(new DateTime($date), "d/m/Y H:M:S");
}

class ObjLocal {
	var	$id;
	var	$title;
};
	
// Email Functions
class EmailFileAttachment {
	function __construct($name, $type, $path){
		$this->name = $name;
		$this->type = $type;
		$this->path = $path;
	}
};

function emailListFromReply($from, $reply, $emailAddresses, $subject, $message, $html = 0, $files = array()){
	global	$sys;
	
//	$ea = implode(",", $emailAddresses);
//	print "emailListFrom: From: '$from' EmailAddress: '$ea' Subject: '$subject'<br>\n";
//	return "emailListFrom: From: '$from' EmailAddress: '$emailAddresses' Subject: '$subject'<br>\n";
	
	$ret = "";
	
	if(is_string($emailAddresses))
		$emailAddressList = explode(",", $emailAddresses);
	else
		$emailAddressList = $emailAddresses;
	
	$subject = htmlToText($subject);

	if($sys->emailSend){
		$headers = "MIME-Version: 1.0\n";
		$headers .= "From: {$sys->siteName}<{$from}>\n";
		$headers .= "Return-Path: {$sys->siteName}<{$from}>\n";
		if($reply != "")
			$headers .= "Reply-To: <{$reply}>\n";

		$headers .= "X-Mailer: PHP/" . phpversion() . "\n";
		
		if($html || count($files)){
			// Do multipart
			$rand = md5(time());
			$mimeBoundary = "==Multipart_Boundary_x{$rand}x";

			// Boundary HTML
			$rand = md5(time() + 6);
			$mimeBoundaryHtml = "==Multipart_Boundary_x{$rand}x";

			$headers .= "Content-Type: multipart/mixed;\n boundary=\"{$mimeBoundary}\";";

			// Add body
			if($html){
				$m = "--{$mimeBoundary}\n";
				$m .= "Content-Type: multipart/alternative;\n boundary=\"{$mimeBoundaryHtml}\";\n\n\n";
				$m .= "--{$mimeBoundaryHtml}\n";
				$m .= "Content-type: text/plain; charset=\"iso-8859-1\"\n";
				$m .= "Content-Transfer-Encoding: 7bit\n\n";
				$m .= htmlToText($message);
				$m .= "\n--{$mimeBoundaryHtml}\n";
				$m .= "Content-type: text/html; charset=\"utf-8\"\n";
				$m .= "Content-Transfer-Encoding: 7bit\n\n";
				$m .= $message;
				$m .= "\n--{$mimeBoundaryHtml}--\n\n";
			}
			else {
				$m = "--{$mimeBoundary}\n" . "Content-type: text/plain; charset=\"iso-8859-1\"\n" . "Content-Transfer-Encoding: 7bit\n\n" . $message . "\n\n";
			}

			$message = $m;

			// Add attachments
			foreach($files as $file){
				if($file instanceof EmailFileAttachment){
					$fp = @fopen($file->path, "rb");
					$data = @fread($fp, filesize($file->path));
					@fclose($fp);
					$data = chunk_split(base64_encode($data));
					$message .= "--{$mimeBoundary}\n";
					$message .= "Content-Type: {$file->type}; name=\"{$file->name}\"\n";
					$message .= "Content-Description: {$file->name}\n";
					$message .= "Content-Disposition: attachment;\n" . " filename=\"{$file->name}\"; size=".filesize($file->path).";\n";
					$message .= "Content-Transfer-Encoding: base64\n\n" . $data;
				}
			}
			$message .= "--{$mimeBoundary}--\n\n";
		}
		else {
			$headers .= "Content-Type: text/plain; charset=\"iso-8859-1\"\n";
			$headers .= "Content-Transfer-Encoding: 7bit\n";
//			$message = trim(htmlToText($message));
		}

		$num = count($emailAddressList);
		$ret = "Sent ${num} emails with subject '${subject}'";

		// Send emails through queue system if available
		if(array_key_exists("emailQueue", $sys->modules)){
			$sys->modules["emailQueue"]->sendEmails($emailAddresses, $headers,  $subject, $message);
		}
		else {
			foreach($emailAddressList as $e){
				$r = mail($e, $subject, $message, $headers);
//				if(!$r)
//					$errors[] = "Error sending to: {$e}";
			}
		}
	}
	else {
		$num = count($emailAddressList);
		$ret = "Emails disabled. Would send ${num} emails with subject '${subject}' from: '{$from}' first address: '{$emailAddressList[0]}'";
	}

	return $ret;
}

function emailListFrom($from, $emailAddresses, $subject, $message, $html = 0, $files = array()){
	return emailListFromReply($from, "", $emailAddresses, $subject, $message, $html, $files);
}

function emailList($emailAddresses, $subject, $message, $html = 0, $files = array()){
	global	$sys;

	return emailListFromReply($sys->siteEmailAddress, "", $emailAddresses, $subject, $message, $html, $files);
}

function emailUsers($userName, $subject, $message, $html = 0, $files = array()){
	global	$sys;

	// First get users email addresses who want emails
	$objList = $sys->db->getObjectList("User", "emailAddress", "`emailSend` = '1' and `name` = '{$userName}'", "");

	$emailAddressList = array();
	foreach($objList as $obj){
		$emailAddressList[] = $obj->emailAddress;
	}
	return emailList($emailAddressList, $subject, $message, $html, $files);
}

function emailAll($subject, $message, $html = 0, $files = array()){
	global	$sys;
	
	if($sys->emailMembership)
		$objList = $sys->db->getObjectList("Membership", "emailAddress", "`emailSend` = '1'", "");
	else
		$objList = $sys->db->getObjectList("User", "emailAddress", "`emailSend` = '1'", "");

	$emailAddressList = array();
	foreach($objList as $obj){
		$emailAddressList[] = $obj->emailAddress;
	}
	return emailList($emailAddressList, $subject, $message, $html, $files);
}

function emailGroup($group, $subject, $message, $html = 0, $files = array()){
	global	$sys;

	if($sys->emailMembership)
		$objList = $sys->db->getObjectList("Membership", "emailAddress", "`emailSend` = '1' and `group` = '{$group}'", "");
	else
		$objList = $sys->db->getObjectList("User", "emailAddress", "`emailSend` = '1' and `group` = '{$group}'", "");

	$emailAddressList = array();
	foreach($objList as $obj){
		$emailAddressList[] = $obj->emailAddress;
	}

	return emailList($emailAddressList, $subject, $message, $html, $files);
}



function runBackground($url){
	global	$sys;
	
#	printf("Run: wget '{$url}' -O '{$sys->baseDir}/tmp/out'<br>\n");
	exec("wget '{$url}' -O {$sys->baseDir}/tmp/out > /dev/null &");
}

function filePathNormalise($path){
	$path = preg_replace('/\/+/s', "/", $path);

	$path = "/$path";
	if (substr($path, -1) != "/")
		$path .= "/";

	$expr = '/\/([^\/]{1}|[^\.\/]{2}|[^\/]{3,})\/\.\.\//s';
	while (preg_match($expr, $path))
		$path = preg_replace($expr, "/", $path);

	$path = substr($path, 0, -1);
	$path = substr($path, 1);
	return $path;
}

/*******************************************************************************
 *	Compatibility functions
 *******************************************************************************
 */
if(0){
function pageDisplay($title, $content){
	global $sys;

	$sys->page->setTitle($sys->siteTitle);
	$sys->page->setCentre($content);
	$sys->page->render();
}

function pageDisplayError(BError $err){
	global $sys;
	
	$back = $_SERVER["HTTP_REFERER"];

	$html = "<div class='error'>\n";
	$html .= "<h1>Error</h1>\n";
	$html .= "{$err->getString()}\n";
	$html .= "</div>\n";
	$html .= "<a href='{$back}'>Back</a>\n";
	
	$sys->page->setStatus("<span class='error'>An error occured</span>");
	pageDisplay("{$sys->siteName} - Error", $html);
}

function pageDisplayPopup($title, $content){
	global $sys;

	$sys->page->popup = 1;
	$sys->page->setTitle($title);
	$sys->page->setCentre($content);
	$sys->page->render();
}
}

?>
