<?php
/*******************************************************************************
 *	BConfig.php		The WebSite configuration
 *	Copyright		Terry Barnaby,	BeamWeb,	2006-05-19
 *******************************************************************************
 */
class BConfig {
	function __construct(){
		$debug = 0;
	}
	
	function init(){
		// Configuration information for project
		if(!isset($_SERVER["HTTP_HOST"])){
			$_SERVER["HTTP_HOST"] = "localhost";
		}

		// HTTP Authorisation fix for CGI based PHP
		if (isset($_SERVER['REDIRECT_HTTP_AUTHORIZATION']) && ($_SERVER['REDIRECT_HTTP_AUTHORIZATION'] != "")){
			$ha = base64_decode(substr($_SERVER['REDIRECT_HTTP_AUTHORIZATION'], 6));
			list($_SERVER['PHP_AUTH_USER'], $_SERVER['PHP_AUTH_PW']) = explode(':', $ha);
			unset($ha);
		}

		// Create base URL
		$baseRoot = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] == 'on') ? 'https' : 'http';

		// As $_SERVER['HTTP_HOST'] is user input, ensure it only contains characters allowed in hostnames.
		$this->baseUrl = $baseRoot .= '://'. preg_replace('/[^a-z0-9-:._]/i', '', $_SERVER['HTTP_HOST']);

		// $_SERVER['SCRIPT_NAME'] can, in contrast to $_SERVER['PHP_SELF'], not be modified by a visitor.
		if($dir = trim(dirname($_SERVER['SCRIPT_NAME']), '\,/')){
			$basePath = "$dir";
			$this->baseUrl .= $basePath;
		}
		else {
			$basePath = '';
		}
		$this->basePath = $basePath;
		$this->baseDir = getcwd();
		
//		print "Init: BaseUrl: {$this->baseUrl} BasePath: {$this->basePath} BaseDir: {$this->baseDir}<br>\n";
//		foreach($_SERVER as $k => $v){
//			print "$k => $v<br>\n";
//		}

		// Chec out browser type
		if(isset($_SERVER['HTTP_USER_AGENT']) and preg_match("/MSIE/", $_SERVER['HTTP_USER_AGENT']))
			$this->browser = "MSIE";
		else
			$this->browser = "";

	}

	
	// Core information
	var	$databaseHost;
	var	$databaseName;
	var	$databaseUser;
	var	$databasePassword;
	var	$databasePrefix;

	// These could be in database ??
	var	$siteName;
	var	$siteTitle;
	var	$siteMotto;
	var	$siteDescription;
	var	$siteKeywords;
	var	$status;
	var	$logo;
	var	$style;
	var	$siteEmailAddress;			// The email address used when sending emails
	var	$siteEmailAdmin;			// The admin email address
	var	$emailSend;				// Allow sending of emails
	var	$moduleNames;				// The list of module names
	var	$userRoles;				// List of user roles
	var	$loginRequired;				// Boolean indicationg that a login is required for normal site access
	var	$loginRegister;				// Allow login account registrations
	var	$loginRegisterValidate;			// Require admin to validate account registrations

	// SMS
	var	$smsSend;				// Enable/disable the sending of SMS
	var	$smsCost;				// Cost of SMS message
	var	$smsUser;				// SMS account user id
	var	$smsPassword;				// SMS account password

	// Locations
	var	$baseDir;				// Website base directory
	var	$baseUrl;				// Website base URL
	var	$basePath;				// The base URI
	var	$browser;				// The Browser in use
	
	var	$debug;					// Debug bitmask
};

?>
