<?php
/*******************************************************************************
 *	BLogin.php		Login and permittions manager
 *	Copyright		Terry Barnaby,	BeamWeb,	2006-05-08
 *******************************************************************************
 */
require_once "Auth.php";
require_once "Auth/HTTP.php";

function loginFunction1()
{
    /*
     * Change the HTML output so that it fits to your
     * application.
     */
    echo "<form method=\"post\" action=\"index.php\">";
    echo "<input type=\"text\" name=\"name\">";
    echo "<input type=\"password\" name=\"password\">";
    echo "<input type=\"submit\">";
    echo "</form>";
}

function loginFunction2()
{
    /*
     * Change the HTML output so that it fits to your
     * application.
     */
    echo "<H1>Please Login to the system</H1>";
}

class BLogin {
	function __construct($sys, $loginFunction, $showLogin = TRUE){
		$this->state = $sys;
		$this->loginFunction = $loginFunction;
		$this->userName = "";
		$this->id = 0;
		$this->enabled = 0;
		$this->fixed = 0;
		$this->roles = "";
		
		$params = array(
			"dsn" => "mysqli://" . $sys->databaseUser . ":" . $sys->databasePassword . "@" . $sys->databaseHost . "/" . $sys->databaseName,
			"table" => $sys->databasePrefix . "User",
			"usernamecol" => "userName",
			"passwordcol" => "userPassword",
			"db_fields" => "*",
		);
		$this->auth = new Auth("DB", $params, $loginFunction, $showLogin);
		$this->auth->setSessionName("_auth_" . $sys->siteName);

		$this->authHttp = new Auth_HTTP("DB", $params);
		$this->authHttp->setRealm($sys->siteName);
		$this->authHttp->setCancelText("<h2>Authorisation Error 401</h2>");
		$this->start();
	}
	
	function start(){
		$this->auth->start();
	}

	// Check user/password using form
	function checkLogin($roles = ""){
		if($res = $this->auth->checkAuth()){
			$this->userName = $this->auth->getUsername();
			$this->id = $this->auth->getAuthData("id");
			$this->roles = $this->auth->getAuthData("roles");
			$this->enabled = $this->auth->getAuthData("enabled");
			$this->fixed = $this->auth->getAuthData("fixed");
			$this->membershipId = $this->auth->getAuthData("membershipId");

			if($this->enabled == 0){
				$this->auth->logout();
				return 0;
			}

			if($roles == "any"){
				if($this->roles == "")
					$res = false;
			}
			else if($roles != ""){
				$r1 = explode(",", $roles);
				$r2 = explode(",", $this->roles);
				$r = array_intersect($r1, $r2);
				if(count($r) == 0)
					$res = false;
			}
		}
		return $res;
	}

	// Check user/password using HTTP
	function checkLoginHttp($roles = ""){
		$this->authHttp->start();
		if($res = $this->authHttp->getAuth()){
			$this->userName = $this->authHttp->getUsername();
			$this->id = $this->authHttp->getAuthData("id");
			$this->enabled = $this->authHttp->getAuthData("enabled");
			$this->roles = $this->authHttp->getAuthData("roles");
			$this->fixed = $this->auth->getAuthData("fixed");
			$this->membershipId = $this->auth->getAuthData("membershipId");

			if($this->enabled == 0){
				$this->auth->logout();
				return 0;
			}

			if($roles != ""){
				$r1 = explode(",", $roles);
				$r2 = explode(",", $this->roles);
				$r = array_intersect($r1, $r2);
				if(count($r) == 0)
					$res = false;
			}
		}
		return $res;
	}

	function logout(){
		$this->auth->logout();
	}
	
	var	$id;
	var	$userName;
	var	$enabled;
	var	$roles;
};

?>
