<?php
/*******************************************************************************
 *	BModule.php		Module interface
 *	Copyright		Terry Barnaby,	BeamWeb,	2008-01-04
 *******************************************************************************
 */
require_once "BEdit.php";

class BModule {
	// Basic Interface routines
	function __construct(&$sys){
		$this->sys = $sys;
		$this->name = "module";
		$this->title = "Module";
		$this->info = "Default Module";
	}
	
	function setName($name){
		$this->name = $name;
	}
	
	function name(){
		return $this->name;
	}
	
	function title(){
		return $this->title;
	}
	
	function info(){
		return $this->info;
	}
	
	// Standard interface
	function checkAccess(){
		return 1;
	}

	function getMenu(){
		return null;
	}
	function getPage($uri){
		return "<H1>Module Default Page</H1>";
	}
	function getPageBlock($uri){
		$o = new BBlock();
		$o->title = "Module Block";
		$o->content ="Module Block< Contents>";
		return $o;
	}
	
	// Admin interface
	function getAdminMenu(){
		return null;
	}
	function getAdminPage($uri){
		return "<H1>Module Default Admin Page</H1>";
	}
	function getAdminPageBlock($uri){
		$o = new BBlock();
		$o->title = "Module Admin Block";
		$o->content ="Module Admin Block Contents";
		return $o;
	}

	function parseUri($uri){
		$this->uri = htmlentities($uri, ENT_QUOTES);
//		print "parseUri: '{$this->uri}'</br>";

		if(isset($_GET["cmd"]))
			$this->cmd = filterString($_GET["cmd"]);
		else
			$this->cmd = "";

		if(isset($_GET["group"]))
			$this->group = filterString($_GET["group"]);
		else
			$this->group = "";
	}
	
	function configs(){
		return array();
	}

	function configEdit($uri){
//		print "Config: "; print_r($this->sys->config); print "</br>";
		configAdd($this->name, $this->configs());
		
		if(isset($_GET["cmd1"]) && ($_GET["cmd1"] == "save")){
			foreach($this->configs() as $c)
				configSet($this->name, $c->name, $_POST[$c->name]);
			return "Config saved";
		}
		else {
			$obj = new StdClass;
			$a = array();
			foreach($this->configs() as $c){
				$name = $this->name . "." . $c->name;
				$a[] = new BViewType($c->name, $c->title, "", array(), 500, 0, $c->description);
				$obj->{$c->name} = $this->sys->config[$name];
			}

			$view = new BEditObj("config", "Configuration", "?cmd=configEdit&cmd1=save", "");
			$view->setView($a);
			$view->setObj($obj);
			return $view->getHtml();
		}
	}
	
	function configEditAsObj($uri){
		configAdd($this->name, $this->configs());
		
		if(isset($_GET["cmd1"]) && ($_GET["cmd1"] == "save")){
			foreach($this->configs() as $c)
				configSet($this->name, $c->name, $_POST[$c->name]);
			return "Config saved";
		}
		else {
			$a = array();
			foreach($this->configs() as $c){
				$a[] = new BViewType($c->name, "", "", array(), 0, 0, $c->description);
			}

			$view = new BEditObj("config", "Configuration", "?cmd=configEdit&cmd1=save", "");
			$view->setView($a);
			$view->setObj($this->sys->config->{$this->name});
			return $view->getHtml();
		}
	}
	
	
	var	$sys;
	var	$name;
	var	$title;
	var	$info;
}

?>
