// Object to hang WebService information
document.ws = {};

function fileExension(filename){
	return ( filename.indexOf('.') > 0 ) ? filename.split('.').pop().toLowerCase() : 'undefined';
}

function createObjDelegate(object, method, arg){
	return function(){
		if(arg !== undefined){
			arguments = [].slice.call(arguments);
			arguments.unshift(arg);
		}
		return method.apply(object, arguments);
	}
}

function inArray(array, elem){
	var len = array.length;
	for(var i = 0; i < len; i++){
		if(array[i] == elem)
			return true;
	}
	return false;
} 

function HtmlNode(p, type, attribs, text){
	node = document.createElement(type);
	p.appendChild(node);
	if(attribs !== undefined){
		for(k in attribs){
			if(k == "className")
				node.className = attribs[k];
			else
				node.setAttribute(k, attribs[k]);
		}
	}
	if(text !== undefined)
		node.appendChild(document.createTextNode(text));

	node.appendNode = function(type, attribs, text){
		return new HtmlNode(this, type, attribs, text);
	}
	node.clearNodes = function(){
		while(this.lastChild)
			this.removeChild(this.lastChild);
	}
	node.setSelected = function(on){
		if(on){
			this.style.color = "white";
			this.style.backgroundColor = "#5b9bda";
		}
		else {
			this.style.color = "";
			this.style.backgroundColor = "";
		}
//		this.className = this.className + " FileIconSelected";
	}

	return node;

}

function eMail(name,domain){
	var href = "mailto:";
	var at = '@';
	document.write('<a href="' +  href + name + at + domain + '">' + name + at + domain + '</a>');
}

function editorTriStateUpdate(obj, vo, change){
//	console.log("editorTriStateUpdate: Value: '" + vo.value + "' change: " + change);
	if(change){
		if(vo.value == ""){
			vo.value = 0;
		}
		else if(vo.value == 0){
			vo.value = 1;
		}
		else {
			vo.value = "";
		}
	}

	if(vo.value == ""){
		obj.indeterminate = 1;
	}
	else if(vo.value == 0){
		obj.checked = 0;
	}
	else {
		obj.checked = 1;
	}

//	console.log("Value: '" + vo.value + "'");
	return true;
}

function editorDateUpdate(formName, name){
//	alert("EditorDateUpdate: FormName: " + formName + "Name: " + name);
	f = document.getElementById(formName);
	dateStr = f[name + "-year"].value + "-" + f[name + "-mon"].value + "-" + f[name + "-day"].value;
	f[name].value = dateStr;
}

function editorDate1(formName, name, value){
	var	dateNow = new Date()
	var	months = new Array("","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");
	var	va = value.split("-");
	
//	alert("Editordate: FormName: " + formName + "Name: " + name + " Value: " + value);
	quotedName = '"' + name + '"';
	
	document.write("<select name='" + name + "-year' onchange='editorDateUpdate(\"" + formName + "\", " + quotedName + ")'>");
	document.write("<option value='0'></option>");
	for(y = dateNow.getFullYear() - 10; y < dateNow.getFullYear() + 10; y++){
		if(y == va[0])
			document.write("<option selected value='" + y + "'>" + y + "</option>");
		else
			document.write("<option value='" + y + "'>" + y + "</option>");
	}
	document.write("</select>");

	document.write("<select name='" + name +"-mon' onchange='editorDateUpdate(\"" + formName + "\", " + quotedName + ")'>");
	for(m = 0; m < 13; m++){
		if(m == va[1])
			document.write("<option selected value='" + m + "'>" + months[m] + "</option>");
		else
			document.write("<option value='" + m + "'>" + months[m] + "</option>");
	}
	document.write("</select>");

	document.write("<select name='" + name +"-day' onchange='editorDateUpdate(\"" + formName + "\", " + quotedName + ")'>");
	for(d = 0; d < 32; d++){
		if(d == 0){
			v = "";
		}
		else {
			v = d;
		}
		if(d == va[2])
			document.write("<option selected value='" + d + "'>" + v + "</option>");
		else
			document.write("<option value='" + d + "'>" + v + "</option>");
	}
	document.write("</select>");

	document.write("<input name='" + name + "' type='hidden' value='" + value + "'>");
}

function editorDate(formName, name, value, help, onChange){
	if(typeof(onChange)==='undefined') onChange = "";
	DateInput(name, false, 'YYYY-MM-DD', value, help, onChange);
}

function editorSelectMultiHorizUpdate(formName, name){
	var	values = "";
	var	options;
	
	f = document.getElementById(formName);
	options = f[name].boptions;
	
//	alert("editorSelectMultiHorizUpdate: FormName: " + formName + " Name: " + name + " N: " + options.length);

	for(i = 0; i < options.length; i++){
		if(f[name + i].checked){
			if(values.length)
				values = values + ",";
			values = values + options[i];
		}
	}
	
	f[name].value = values;
//	alert("editorSelectMultiHorizUpdate: FormName: " + formName + " Name: " + name + " N: " + options.length + " V: " + values);
}

function editorSelectMultiHoriz(formName, name, options, value, help){
	optionList = options.split(",");
	valueList = value.split(",");
	
//	alert("editorSelectMultiHoriz: FormName: " + formName + " Name: " + name + " OptionsLen: " + optionList.length);

	f = document.getElementById(formName);
	
	document.write("<table class='EditSelectMultiHoriz' rules='all' title='" + help + "'><tr>");
	document.write("<input type='hidden' name='" + name + "' value='" + value + "'>");

	for(i in optionList){
		document.write("<td>");
		document.write(optionList[i] + "<br>");
		if(inArray(valueList, optionList[i]))
			ch = "checked";
		else
			ch = "";
			
		document.write("<input type='checkbox' name='" + name + i + "' " + ch + " onchange='editorSelectMultiHorizUpdate(\"" + formName + "\", \"" + name + "\")'>");
		document.write("</td>");
	}
	document.write("</tr></table>\n");
	f[name].boptions = optionList;
}

function editorSelectMultiUpdateCheckbox(formName, name){
	var	values = "";
	var	options;
	
	f = document.getElementById(formName);
	options = f[name].boptions;
	
//	alert("editorSelectMultiHorizUpdate: FormName: " + formName + " Name: " + name + " N: " + options.length);

	for(i = 0; i < options.length; i++){
		if(f[name + i].checked){
			if(values.length)
				values = values + ",";
			values = values + options[i];
		}
	}
	
	f[name].value = values;
//	alert("editorSelectMultiHorizUpdate: FormName: " + formName + " Name: " + name + " N: " + options.length + " V: " + values);
}

function editorSelectMultiCheckbox(formName, name, options, value, help){
	optionList = options.split(",");
	valueList = value.split(",");
	
//	alert("editorSelectMultiHoriz: FormName: " + formName + " Name: " + name + " OptionsLen: " + optionList.length);

	f = document.getElementById(formName);
	
	document.write("<ul class='EditSelectMultiCheckbox' style='list-style-type: none; margin: 0; padding: 0; height: 100px; overflow: auto; overflow-x: hidden;' title='" + help + "'>");
	document.write("<input type='hidden' name='" + name + "' value='" + value + "'>");

	for(i in optionList){
		document.write("<li><label for='" + name + i + "'>");
		if(inArray(valueList, optionList[i]))
			ch = "checked";
		else
			ch = "";
			
		document.write("<input type='checkbox' name='" + name + i + "' id='" + name + i + "'" + ch + " onchange='editorSelectMultiUpdateCheckbox(\"" + formName + "\", \"" + name + "\")'>");
		document.write(optionList[i] + "</label></li>");
	}
	document.write("</ul>\n");
	f[name].boptions = optionList;
}

// Internet Explorer Hacks
function pageWidthMinMax(a, b){
	var	nw = "auto";
	var	w = document.documentElement.clientWidth;
	if(w>=b){nw=b+"px";}
	if(w<=a){nw=a+"px";}
//	alert("DocWidth: " + w + " NewWidth: " + nw);
	return nw;
}

function formOption(list, value){
	ret = "";
	for(var i = 0; i < list.length; i++){
		if(list[i] == value)
			ret = ret + "<option selected>" + list[i] + "</option>";
		else
			ret = ret + "<option>" + list[i] + "</option>";
	}
	return ret;
}

// File uploader with image resize
function FileUploaderForm(name, line, width, height){
	this.name = name;
	this.response = "";

//	alert("FileUploaderForm: Start");

	if(width === undefined) width = 1024;
	if(height === undefined) height = 768;
	
	pictureSizes = new Array("1024x768", "640x480", "320x240", "160x120");
	sizeOpt = String(width) + "x" + String(height);

	if(line){
		html = "<span id='" + name + "_uploader'><input id='" + name + "_filelist' type='text' readonly size='30'></input>";
		html += "<select id='" + name + "_imgsize'>" + formOption(pictureSizes, sizeOpt) + "</select>";
		html += "<button id='" + name + "_pickfiles'>Browse</button><input name='fileUploader' value='0' hidden></input></span>";
	}
	else {
		html = "<div id='" + name + "_uploader'><div style='background: #E0DFDE;'><b>Upload pictures and files</b></div>";
		html += "<input id='" + name + "_filelist' size='30'></input>";
		html += "<span><button id='" + name + "_pickfiles'>Add File</button><input type='hidden' name='fileUploader' value='0'></input>";
		html += "<select id='" + name + "_imgsize'>" + formOption(pictureSizes, sizeOpt) + "</select>";
		html += "</span></div>";
	}
	document.writeln(html);

	this.filelist = document.getElementById(name + '_filelist');
	this.imgSize = document.getElementById(name + '_imgsize');
	this.form = this.filelist.form;
	this.formOnSubmit = this.form.onsubmit;

	this.uploader = new plupload.Uploader({
		runtimes : 'html5,flash,browserplus, silverlight',
		file_data_name: this.name,
		browse_button : name + '_pickfiles',
		container: name + '_uploader',
		max_file_size : '250mb',
		url : this.form.action,
		resize : {width: width, height: height, quality : 90},
		flash_swf_url : '/lib/plupload/plupload.flash.swf',
		multipart: 1,
		multipart_params: { 'fileUploader': '1' },
		silverlight_xap_url : '/lib/plupload/plupload.silverlight.xap',
		filters : [
			{title : "Image files", extensions : "jpg,gif,png,wbmp,xbm"},
			{title : "Document files", extensions : "pdf,doc,docx,odt,xls,xlsx,ods,sav,svg"},
			{title : "Video files", extensions : "wmv,mov,mp4,avi"},
			{title : "Other files", extensions : "gpx,mp3,txt,patch,zip,gz,h,c,cpp,hpp"}
		]
	});
	
	this.addFile = function(up, files){
//		alert("AddFile ok");
		for(var i in files) {
			this.filelist.value = files[i].name + ' (' + plupload.formatSize(files[i].size) + ')';
		}
	}

	this.error = function(up, err){
		alert("Error: " + err.message);
//		this.filelist.innerHTML = "<div>Error: " + err.code + ", Message: " + err.message + (err.file ? ", File: " + err.file.name : "") + "</div>";
	        up.refresh(); // Reposition Flash/Silverlight
	}

	this.progress = function(up, file) {
		this.filelist.value = file.name + ' (' + plupload.formatSize(file.size) + ')' +  file.percent + '%';
	}
	
	this.fileComplete = function(up, file, result){
//		alert("File Uploaded ok: result: " + result.status + " data: " + result.response.substr(0, 64));
		this.response = result.response;
	}

	this.complete = function(up, files){
//		alert("Files Uploaded complete");
		document.open();
		document.write(this.response);
		document.close();
	}

	this.onsubmit = function(){
		//alert("OnSubmit start: action: " + this.form.action);
		
		// Make sure all CKEitor instalances have setup
		//this.formOnSubmit();
		for(instance in CKEDITOR.instances)
			CKEDITOR.instances[instance].updateElement();

		// Add other form fields
		for(var i = 0; i < this.form.length; i++){
			v = this.form.elements[i];
			if(v.name){
				this.uploader.settings.multipart_params[v.name] = v.value;
			}
		}
		this.uploader.settings.multipart_params["fileUploader"] = "1";
//		alert("Submit start");

		// Files in queue upload them first
		if(this.uploader.files.length > 0){
			this.uploader.start();
		}
		else {
			//this.formSubmit();
			return true;
		}

		return false;
	}
	
	this.imagSizeChanged = function(){
		value = this.imgSize[this.imgSize.selectedIndex].text;
		if(value == "1024x768"){
			this.uploader.settings.resize = {width: 1024, height: 768, quality : 90};
		}
		else if(value == "640x480"){
			this.uploader.settings.resize = {width: 640, height: 480, quality : 90};
		}
		else if(value == "320x240"){
			this.uploader.settings.resize = {width: 320, height: 240, quality : 90};
		}
		else if(value == "160x120"){
			this.uploader.settings.resize = {width: 160, height: 120, quality : 90};
		}
	}
	

	this.uploader.bind('FilesAdded', createObjDelegate(this, this.addFile));
	this.uploader.bind('Error', createObjDelegate(this, this.error));
	this.uploader.bind('UploadProgress', createObjDelegate(this, this.progress));
	this.uploader.bind('FileUploaded', createObjDelegate(this, this.fileComplete));
	this.uploader.bind('UploadComplete', createObjDelegate(this, this.complete));
	this.imgSize.onchange = createObjDelegate(this, this.imagSizeChanged);
	this.form.onsubmit = createObjDelegate(this, this.onsubmit);
	this.uploader.init();
}

// File and Image uploader using plupload with client side image resising
//
function FileUploader(div, name, url, width, height){
	this.name = name;

	if(width === undefined) width = 1024;
	if(height === undefined) height = 768;

	// Create HTML
	html = "<div id='" + name + "_uploader'><div style='background: #E0DFDE;'><b>Upload pictures and files</b></div>";
	html += "<div id='" + name + "_filelist' style='height:100px;'></div>";
	html += "<span><button id='" + name + "_pickfiles'>Add Files</button><button id='" + name + "_upload'>Upload</button><input type='hidden' name='fileUploader' value='0'></input>";
	html += "<select id='" + name + "_imgsize'><option>1024x768</option><option>640x480</option><option>320x240</option><option>160x120</option></select>";
	html += "</span></div>";
	div.innerHTML = html

	this.filelist = document.getElementById(name + '_filelist');
	this.imgSize = document.getElementById(name + '_imgsize');
	this.uploadButton = document.getElementById(name + '_upload');
	this.filesUploaded = new Array();

	this.uploader = new plupload.Uploader({
		runtimes : 'html5,flash,browserplus, silverlight',
		file_data_name: "upload[]",
		browse_button : name + '_pickfiles',
		container: name + '_uploader',
		drop_element: name + '_filelist',
		max_file_size : '250mb',
		url: url,
		multi_selection: 1,
		resize : {width: width, height: height, quality : 90},
		multipart: 1,
		multipart_params: { 'dir': '' },
		silverlight_xap_url : '/lib/plupload/plupload.silverlight.xap',
		flash_swf_url : '/lib/plupload/plupload.flash.swf',
		filters : [
			{title : "Image files", extensions : "jpg,gif,png,wbmp,xbm"},
			{title : "Document files", extensions : "pdf,doc,docx,odt,xls,xlsx,ods,sav,svg"},
			{title : "Video files", extensions : "wmv,mov,mp4,avi"},
			{title : "Other files", extensions : "gpx,mp3,txt,patch,zip,gz,h,c,cpp,hpp"}
		]
	});
	
	this.setDir = function(dir){
		this.uploader.settings.multipart_params["dir"] = dir;
	}
	
	this.setOnComplete = function(onComplete){
		this.onComplete = onComplete;
	}
	
	this.addFile = function(up, files){
//		alert("AddFile ok: " + String(files.length));
		if((this.filelist.innerHTML == "Drag and Drop") || (this.filelist.innerHTML == "Completed"))
			this.filelist.innerHTML = "";

		for(var i in files) {
			this.filelist.innerHTML += files[i].name + ' (' + plupload.formatSize(files[i].size) + ')' + '<br>';
		}
		this.files = files;
		this.filesUploaded = new Array();
	}

	this.progress = function(up, file) {
//		alert("Progress");
		this.filelist.innerHTML = file.name + ' (' + plupload.formatSize(file.size) + ')' +  file.percent + '%';
	}
	
	this.error = function(up, err){
//		alert("Error");
		this.filelist.innerHTML = "<div>Error: " + err.code + ", Message: " + err.message + (err.file ? ", File: " + err.file.name : "") + "</div>";
	        up.refresh(); // Reposition Flash/Silverlight
	}

	this.fileUploaded = function(up, files, info){
//		console.log("fileUploaded: " + files + " : " + info);
		obj = JSON.parse(info.response);
		this.filesUploaded.push(obj);
//		console.log("fileUploaded: " + obj);
	}

	this.complete = function(up, files){
//		console.log("complete: " + files);
		this.filelist.innerHTML = "Completed";
//		browser.refresh();
		if(this.onComplete)
			this.onComplete(this.filesUploaded);
	}
	
	this.upload = function(){
//		alert("Upload to: " + this.uploader.settings.url);
		this.uploader.start();
	}

	this.imagSizeChanged = function(){
		value = this.imgSize[this.imgSize.selectedIndex].text;
		if(value == "1024x768"){
			this.uploader.settings.resize = {width: 1024, height: 768, quality : 90};
		}
		else if(value == "640x480"){
			this.uploader.settings.resize = {width: 640, height: 480, quality : 90};
		}
		else if(value == "320x240"){
			this.uploader.settings.resize = {width: 320, height: 240, quality : 90};
		}
		else if(value == "160x120"){
			this.uploader.settings.resize = {width: 160, height: 120, quality : 90};
		}
	}
	
	this.info = function(up, params){
		if(params.runtime == "html5"){
			this.filelist.innerHTML = "Drag and Drop";
		}
	}
	
	this.uploader.bind('Init', createObjDelegate(this, this.info));
	this.uploader.bind('FilesAdded', createObjDelegate(this, this.addFile));
	this.uploader.bind('UploadProgress', createObjDelegate(this, this.progress));
	this.uploader.bind('Error', createObjDelegate(this, this.error));
	this.uploader.bind('UploadComplete', createObjDelegate(this, this.complete));
	this.uploader.bind('FileUploaded', createObjDelegate(this, this.fileUploaded));
	this.imgSize.onchange = createObjDelegate(this, this.imagSizeChanged);
	this.uploadButton.onclick = createObjDelegate(this, this.upload);

	this.uploader.init();
//	this.uploader.refresh();
}


function PictureUploader(name, url, width, height){
	this.name = name;
	this.numFiles = 0;
	pictureSizes = new Array("1024x768", "640x480", "320x240", "160x120");

	if(width === undefined) width = 1024;
	if(height === undefined) height = 768;
	sizeOpt = String(width) + "x" + String(height);

	// Create HTML
	html = "<div class='PictureUploader' id='" + name + "_uploader' style='clear: both; float: left;'><div class='PictureUploader_Header' style='background: #E0DFDE;'><b>Upload pictures</b></div>";
	html += "<div class='PictureUploader_Filelist' id='" + name + "_filelist' style='clear: both; float: left; overflow: auto;'></div>";
	html += "<div style='clear: both;'><span><button class='PictureUploader_Button' id='" + name + "_pickfiles'>Add Files</button><button class='PictureUploader_Button' id='" + name + "_upload'>Upload</button><input type='hidden' name='fileUploader' value='0'></input>";
	html += "<select class='PictureUploader_Select' id='" + name + "_imgsize'>" + formOption(pictureSizes, sizeOpt) + "</select>";
	html += "</span></div></div>";
	document.writeln(html);

	this.filelist = document.getElementById(name + '_filelist');
	this.imgSize = document.getElementById(name + '_imgsize');
	this.uploadButton = document.getElementById(name + '_upload');
	this.filesUploaded = new Array();
	this.fileTitles = [];


	this.uploader = new plupload.Uploader({
		runtimes : 'html5,flash,browserplus, silverlight',
		file_data_name: "upload[]",
		browse_button : name + '_pickfiles',
		container: name + '_uploader',
		drop_element: name + '_filelist',
		max_file_size : '250mb',
		url: url,
		multi_selection: true,
		resize : {width: width, height: height, quality : 90},
		multipart: 1,
		multipart_params: { 'dir': '' },
		silverlight_xap_url : '/lib/plupload/plupload.silverlight.xap',
		flash_swf_url : '/lib/plupload/plupload.flash.swf',
		filters : [
			{title : "Image files", extensions : "jpg,gif,png,wbmp,xbm"},
			{title : "Document files", extensions : "pdf,doc,docx,odt,xls,xlsx,ods,sav,svg"},
			{title : "Video files", extensions : "wmv,mov,mp4,avi"},
			{title : "Other files", extensions : "gpx,mp3,txt,patch,zip,gz,h,c,cpp,hpp"}
		]
	});
	
	this.setDir = function(dir){
		this.uploader.settings.multipart_params["dir"] = dir;
	}
	
	this.setOnComplete = function(onComplete){
		this.onComplete = onComplete;
	}
	
	this.addFile = function(up, files){
//		alert("AddFile: " + String(files.length));
		if(this.numFiles == 0)
			this.filelist.innerHTML = "";

		for(var i in files) {
			var pn = name + "_preview" + String(this.numFiles);

			if(this.numFiles == 0){
				this.filelistTable = new HtmlNode(this.filelist, "table");
				hr = new HtmlNode(this.filelistTable, "tr");
				new HtmlNode(hr, "th", {}, "File");
				new HtmlNode(hr, "th", {}, "Size (MBytes)");
				new HtmlNode(hr, "th", {}, "Picture");
				new HtmlNode(hr, "th", {}, "Title");
			}

			hr = new HtmlNode(this.filelistTable, "tr");
			new HtmlNode(hr, "td", {}, files[i].name);
			new HtmlNode(hr, "td", {}, plupload.formatSize(files[i].size));
			hi = new HtmlNode(hr, "td");
			hn = new HtmlNode(hr, "td");
			this.fileTitles.push(new HtmlNode(hn, "input", { id: name + "_title" +  String(this.numFiles)}));
			
			img = new moxie.image.Image();
			img.embedObj = hi;
			img.onload = function() {
				this.embed(this.embedObj, { width: 50, height: 50, crop: false });
			};

			img.onembedded = function() {
				this.destroy();
			};

			img.onerror = function() {
				this.destroy();
			};

			img.load(files[i].getSource());
			files[i].num = this.numFiles;
			this.numFiles += 1;
		}      

		this.filesUploaded = new Array();
	}
	
	this.beforeUpload = function(up, file) {
//		alert("beforeUpload: " + String(file.num));
		this.uploader.settings.multipart_params["title"] = this.fileTitles[file.num].value;
	}
	

	this.progress = function(up, file) {
//		alert("Progress");
		this.filelist.innerHTML = file.name + ' (' + plupload.formatSize(file.size) + ')' +  file.percent + '%';
	}
	
	this.error = function(up, err){
//		alert("Error");
		this.filelist.innerHTML = "<div>Error: " + err.code + ", Message: " + err.message + (err.file ? ", File: " + err.file.name : "") + "</div>";
	        up.refresh(); // Reposition Flash/Silverlight
		this.numFiles = 0;
	}

	this.fileUploaded = function(up, files, info){
//		console.log("fileUploaded: " + files + " : " + info);
		obj = JSON.parse(info.response);
		if(obj.error != ""){
			this.filelist.innerHTML = "<div>Error: " + obj.error + "</div>";
			this.numFiles = 0;
			up.stop();
		}
		else {
			this.filesUploaded.push(obj.status);
		}
	}

	this.complete = function(up, files){
//		console.log("complete: " + files);
		this.filelist.innerHTML = "Completed";
		this.numFiles = 0;
		if(this.onComplete)
			this.onComplete(this.filesUploaded);
	}
	
	this.upload = function(){
//		alert("Upload to: " + this.uploader.settings.url);
		this.uploader.start();
	}

	this.imagSizeChanged = function(){
		value = this.imgSize[this.imgSize.selectedIndex].text;
		if(value == "1024x768"){
			this.uploader.settings.resize = {width: 1024, height: 768, quality : 90};
		}
		else if(value == "640x480"){
			this.uploader.settings.resize = {width: 640, height: 480, quality : 90};
		}
		else if(value == "320x240"){
			this.uploader.settings.resize = {width: 320, height: 240, quality : 90};
		}
		else if(value == "160x120"){
			this.uploader.settings.resize = {width: 160, height: 120, quality : 90};
		}
	}
	
	this.info = function(up, params){
		if(params.runtime == "html5"){
			this.filelist.innerHTML = "Drag and Drop files here or use Add Files button.<br/>";
			this.filelist.innerHTML += "Optionally you can add a title for each picture.<br/>";
			this.filelist.innerHTML += "Then click on the Upload button.";
		}
	}
	
	this.uploader.bind('Init', createObjDelegate(this, this.info));
	this.uploader.bind('FilesAdded', createObjDelegate(this, this.addFile));
	this.uploader.bind('BeforeUpload', createObjDelegate(this, this.beforeUpload));
	this.uploader.bind('UploadProgress', createObjDelegate(this, this.progress));
	this.uploader.bind('Error', createObjDelegate(this, this.error));
	this.uploader.bind('FileUploaded', createObjDelegate(this, this.fileUploaded));
	this.uploader.bind('UploadComplete', createObjDelegate(this, this.complete));
	this.imgSize.onchange = createObjDelegate(this, this.imagSizeChanged);
	this.uploadButton.onclick = createObjDelegate(this, this.upload);

	this.uploader.init();
}
