<?php
require_once "BModule.php";
require_once "BBlock.php";
require_once "BView.php";
require_once "BEdit.php";
require_once "content/content.php";

class ViewSettings {
	function __construct(){
	}
	
	function getCategory(){
		if(isset($_GET["category"])){
			return filterString($_GET["category"]);
		}
		else {
			return "all";
		}
	}
	
	function getHtml(){
		$title = "";
		$args = array_merge(array("all"), categoryGetList("content"));
		$value = "";
		
		if(isset($_GET["category"])){
			$value = filterString($_GET["category"]);
		}
		
		$form = new BHtmlNode("form", "method='get'");
		$t = &$form->appendNode("table");
		$r = &$t->appendNode("tr");
		$r->appendNode("td", "", "Categories to list");
		$c = &$r->appendNode("td");

		$sel = &$c->appendNode("select", "name='category' {$title}");
		foreach($args as $item){
			if($item == $value)
				$sel->appendNode("option", "selected='selected'", $item);
			else
				$sel->appendNode("option", "", $item);
		}

		$c = &$r->appendNode("td");
		$c->appendNode("input", "type='submit' name='cmd' value='Set'");
		return $form->render();
	}
};

class Document extends BModule {
	// Basic Interface routines
	function __construct(&$sys){
		parent::__construct($sys);
		$this->name = "document";
		$this->title = "Document";
		$this->info = "Document Admin module";
		$this->moduleUrl = "document";
		$this->group = "";

		// Add HTML functions
		$this->sys->htmlFuncs[] = "documentList";
	}
	
	function checkAccess(){
		return $this->sys->login->checkLogin("admin") || $this->sys->login->checkLogin("adminGroup" . $this->group);
	}

	// Admin Interface
	function getMenu(){
		return new BMenu("Documents", "/{$this->name}", "", array("Document List" => "/{$this->name}", "Document Add" => "/{$this->name}?cmd=add"));
	}

	function getPage($uri){
		$this->parseUri($uri);
		
		if($this->checkAccess()){
			switch($this->cmd){
			case "viewList":		return $this->editList();		break;

			case "view":			return $this->view();			break;
			case "uploadNew":		return $this->uploadNew();		break;
			case "uploadNewVersion":	return $this->uploadNewVersion(filterToInt($_GET["id"]), 0);	break;
			case "uploadNewsletter":	return $this->uploadNewsletter();	break;
			case "edit":			return $this->edit(filterToInt($_GET["id"]));	break;
			case "save":			return $this->save();			break;
			case "delete":			return $this->delete(filterToInt($_GET["id"]));	break;
			case "deleteDo":		return $this->deleteDo(filterToInt($_GET["id"]));	break;
			default: 			return $this->editList();		break;
			}
		}
		else {
			switch($this->cmd){
			case "view":			return $this->view();			break;
			default: 			return $this->viewList();		break;
			}
		}
	}

	function getPageBlock($uri){
		if($this->checkAccess()){
			$o = new BMenu("Documents", "", "", array(
				new BMenu("List", "", "href='?cmd=viewList&group={$this->group}'"),
				new BMenu("", "", ""),
				new BMenu("View", "", "onmouseover='this.href = \"?cmd=view&group={$this->group}&id=\" + document.ws.list.objId'"),
				new BMenu("Upload New", "", "onmouseover='this.href = \"?cmd=uploadNew&group={$this->group}\"'"),
				new BMenu("Upload New Version", "", "onmouseover='this.href = \"?cmd=uploadNewVersion&group={$this->group}&id=\" + document.ws.list.objId'"),
				new BMenu("Edit Information", "", "onmouseover='this.href = \"?cmd=edit&group={$this->group}&id=\" + document.ws.list.objId'"),
				new BMenu("Delete", "", "onmouseover='this.href = \"?cmd=delete&group={$this->group}&id=\" + document.ws.list.objId'"),
				new BMenu("", "", ""),
				new BMenu("Upload Newsletter", "", "href='?cmd=uploadNewsletter&group={$this->group}'"),
				));
			return $o;
		}
		else {
			return Null;
		}
	}


	function viewList(){
		$page = "<h1>Documents</h1>";

		$settings = new ViewSettings();
		$page = $page . $settings->getHtml() . "<br>";

		if($this->group)
			$where = "`group`='" . dbEscapeString($this->group) . "'";
		else
			$where = "";

		$category = dbEscapeString($settings->getCategory());
		if($category != "all"){
			if($where)
				$where .= " and ";
			$where .= "`category`='{$category}'";
		}

		$view = new BViewDatabase("documents");
		$view->setView(array(
			new BViewType("id", "Id"),
			new BViewType("title", "Title"),
			new BViewType("category", "Category"),
			new BViewType("group", "Group"),
			new BViewType("version", "Version"),
			new BViewType("dateCreated", "Date Created", "date"),
			new BViewType("pdf", "PDF", "link", array("PDF", "?cmd=view&type=pdf&id={\$obj->id}")),
//			new BViewType("html", "Html", "link", array("HTML", "?cmd=view&type=html&id={\$obj->id}")),
			new BViewType("master", "Master", "link", array("Master", "?cmd=view&type=master&id={\$obj->id}"))));


		$view->setSelection($where);

		if(!$view->order)
			$view->setOrder("category,title,!version");

		$view->setTable("Content");
		$page = $page . $view->getHtml();

		return $page;
	}

	function editList(){
		$page = "<h3>Documents</h3>";

		$settings = new ViewSettings();
		$page = $page . $settings->getHtml() . "<br>";

		if($this->group)
			$where = "`group`='" . dbEscapeString($this->group) . "'";
		else
			$where = "";

		$category = dbEscapeString($settings->getCategory());
		if($category != "all"){
			if($where)
				$where .= " and ";
			$where .= "`category`='{$category}'";
		}

		$view = new BViewDatabase("list", "select");
		$view->setView(array(
			new BViewType("id", "Id"),
			new BViewType("type", "Type"),
			new BViewType("title", "Title"),
			new BViewType("version", "Version"),
			new BViewType("category", "Category"),
			new BViewType("group", "Group"),
			new BViewType("description", "Description"),
			new BViewType("dateCreated", "Date Created", "date"),
			new BViewType("pdf", "PDF", "link", array("PDF", "?cmd=view&type=pdf&id={\$obj->id}")),
//			new BViewType("html", "Html", "link", array("HTML", "?cmd=view&type=html&id={\$obj->id}")),
			new BViewType("master", "Master", "link", array("Master", "?cmd=view&type=master&id={\$obj->id}"))));

		$view->setSelection($where);

		if(!$view->order)
			$view->setOrder("category,title,!version");

		$view->setTable("Content");
		$page = $page . $view->getHtml();

		return $page;
	}
	
	function view(){
//		$id = filterToInt($_GET["id"]);
//		print "View Document: Type: {$_GET["type"]} Id: {filterToInt($_GET["id"])} Id: {$id}<br>";

		if(isset($_GET["title"])){
			$obj = contentGetObjTitled(dbEscapeString($_GET["title"]));
		}
		else {
			$obj = contentGetObj(filterToInt($_GET["id"]));
		}

		if(isset($_GET["type"]))
			$type = filterString($_GET["type"]);
		else
			$type = "pdf";
		
		if($type == "master")
			$type = $obj->type;
		
		return contentView("Documents", $obj, $type);
	}
	
	function edit($arg){
		$page = "<h2>Edit Document</h2>";

		if($arg == "undefined"){
			$this->sys->pageDisplayError(new BError(1, "No object selected"));
			return "";
		}
		else if(is_object($arg)){
			$obj = $arg;
		}
		else if($arg == 0){
			$obj = $this->sys->db->getNewObject("Content");
			$obj->version = 0;
			$obj->group = $this->group;
			$obj->dateCreated = strftime("%Y-%m-%d");
			$obj->dateModified = $obj->dateCreated;
		}
		else {
			$obj = $this->sys->db->getObject("Content", $arg);
		}


		$obj->MAX_FILE_SIZE = (8*1024*1024);
		$obj->fileName = "";

		$view = new BEditObj("fileUpload", "Document Upload", "?cmd=save&group={$this->group}", "");
		$view->setView(array(
			new BViewType("id", "", "hidden"),
			new BViewType("type", "", "hidden"),
			new BViewType("version", "", "hidden"),
			new BViewType("filePath", "", "hidden"),
			new BViewType("MAX_FILE_SIZE", "", "hidden"),
			new BViewType("title", "", "text", "", 400, 0),
			new BViewType("category", "", "select", categoryGetList("content")),
			new BViewType("group", "Group", "select", array_merge(array(""), $this->sys->groups)),
			new BViewType("description", "", "textarea", "", 400, 100),
			new BViewType("dateCreated", "Date Created", "date"),
			new BViewType("fileName", "", "file", "", 400, 0),
			));

		$view->setHelp("title", "Enter the title.");
		$view->setHelp("category", "Enter the category by selecting one from the list.");
		$view->setHelp("description", "Optionaly enter a description. This can be multiple lines long and contain web addresses etc");
		$view->setHelp("fileName", "Enter a local file name. You can use the Browse button to use a file selector dialog");

		$view->setObj($obj);
		
		$page .= $view->getHtml();
		$page .= "<p>The document system supports the file types: pdf,doc,docx,xls,xlsx,odt,ods,sav,svg,gpx.</p>";
		$page .= "<p>If a non PDF file is uploaded the system will attempt to convert it into pdf format.</p>";

		return $page;
	}
	
	function uploadNew(){
		return $this->edit("0");
	}

	function uploadNewVersion($id, $sendEmail){
		if($id == "undefined"){
			$this->sys->pageDisplayError(new BError(1, "No object selected"));
			return;
		}
		else {
			$obj = contentGetObj($id);
			$obj->id = 0;
			$obj->dateCreated = strftime("%Y-%m-%d");
			$obj->dateModified = $obj->dateCreated;
			$obj->MAX_FILE_SIZE = (8*1024*1024);
			$obj->fileName = "";
			$obj->sendEmail = $sendEmail;

			$f = new BEditObj("fileUpload", "Document Upload", "?cmd=save&group={$this->group}", "");
			$f->setSaveButtonTitle("Upload Document");
			$f->setView(array(
				new BViewType("id", "", "hidden"),
				new BViewType("type", "", "hidden"),
				new BViewType("version", "", "hidden"),
				new BViewType("filePath", "", "hidden"),
				new BViewType("MAX_FILE_SIZE", "", "hidden"),
				new BViewType("title", "", "text", "", 400, 0),
				new BViewType("category", "", "select", categoryGetList("content")),
				new BViewType("group", "Group", "select", array_merge(array(""), $this->sys->groups)),
				new BViewType("description", "", "textarea", "", 400, 100),
				new BViewType("dateCreated", "Date Created", "date"),
				new BViewType("fileName", "", "file", "", 400, 0),
				));

			if($sendEmail){
				$f->viewTypeList[] = new BViewType("sendEmail", "", "checkbox");
			}
			
			$f->setHelp("title", "Enter the title.");
			$f->setHelp("category", "Enter the category by selecting one from the list.");
			$f->setHelp("description", "Optionaly enter a description. This can be multiple lines long and contain web addresses etc");
			$f->setHelp("fileName", "Enter a local file name. You can use the Browse button to use a file selector dialog");

			$f->setObj($obj);

			$page = $f->getHtml();
			$page .= "<p>The document system supports the file types: pdf,doc,docx,xls,xlsx,odt,ods,sav,svg,gpx.</p>";
			$page .= "<p>If a non PDF file is uploaded the system will attempt to convert it into pdf format.</p>";

			$this->sys->pageDisplay("Documents", $page);
		}
	}

	function uploadNewsletter(){
		$obj = contentGetObjTitled("Newsletter");
//		print "Newsletter {$obj->id}Ver: {$obj->version}";
		return $this->uploadNewVersion($obj->id, 0);
	}
	
	
	function save(){
		$page = "";
		$fileType = "";

		unset($_POST['cmd']);
		
		if($_POST['id'] == 0)
			$obj = new BObjContent();
		else
			$obj = $this->sys->db->getObject("Content", $_POST['id']);

		$obj->set($_POST);
		$obj->dateModified = strftime("%Y-%m-%d");

		if($err = $obj->validate()){
			$items = implode(",", array_keys($err));
			$this->sys->status = "<span class='editError'>Error in form data in fields: $items</span>";
			return $this->edit($obj);
		}

		if(isset($_FILES["fileName"]) and ($_FILES["fileName"]["name"] != "")){
			$obj->version = $obj->version + 1;
			$pi = pathinfo($_FILES["fileName"]["name"]);
			$obj->fileNameOriginal = $_FILES["fileName"]["name"];
			$obj->type = strtolower($pi['extension']);
		}

		if($obj->filePath == "")
			$obj->filePath = "/files/documents/document-{$obj->id}-{$obj->version}.{$obj->type}";
		
		// Add to database
		if($obj->id){
			$this->sys->db->putObject("Content", $obj);
		}
		else {
			$obj = $this->sys->db->appendObject("Content", $obj);
			$obj->filePath = "/files/documents/document-{$obj->id}-{$obj->version}.{$obj->type}";
			$this->sys->db->putObject("Content", $obj);
		}
		
//		print_r($_FILES);
		if(isset($_FILES["fileName"]) and ($_FILES["fileName"]["name"] != "")){
			$pi = pathinfo($obj->filePath);
			$dir = $this->sys->baseDir . $pi['dirname'];
//			print "Dir: {$dir}<br>";
			
			if(!file_exists($dir))
				mkdir($dir, 0777, 1);
			
			// Move file
			if(!move_uploaded_file($_FILES["fileName"]["tmp_name"], $this->sys->baseDir . $obj->filePath))
				$page .= "Move Error";
			else {
				$ext = strtolower(pathinfo($obj->filePath, PATHINFO_EXTENSION));
				if($ext != "pdf"){
					$s = $this->sys->baseDir . $obj->filePath;
					$d = $this->sys->baseDir . $pi['dirname'] . "/" . $pi['filename'] . ".pdf";

					emailList("terry@beam.ltd.uk", "Beam: Document Convert", "Document to be converted: {$this->sys->baseUrl}{$obj->filePath} ext: '${ext}'");
					if(1){
						$res = contentConvert($s, $d);

						if($res == False){
							$this->sys->pageDisplayError(new BError(1, "The document could not be converted to PDF at this time, this will happen automatically later."));
							exit();
						}
					}
					else {
						runBackground($this->sys->baseUrl . "/content?cmd=contentConvert&id=$obj->id"); 
					}
				}
			}
		}

		if(isset($_POST['sendEmail']) && ($_POST['sendEmail'] == "1") && ($obj->title == "Newsletter")){
			emailAll("{$this->sys->siteName}: News: {$obj->title}", "A new school Newsletter is available at: {$this->sys->baseUrl}/document?id={$obj->id}");
		}

		$page .= "<h3>Document has been saved</h3>";

		return $page;
	}

	function delete($id){
		// Check role
		if(!$this->sys->login->checkLogin("adminDelete") && !$this->sys->login->checkLogin("adminGroup" . $this->group)){
			$this->sys->pageDisplayError(new BError(1, "You are not authorised to delete items. Only users with the 'adminDelete' role can perform this."));
			exit();
		}

		if($id == "undefined"){
			$this->sys->pageDisplayError(new BError(1, "No object selected"));
			return;
		}

		$obj = $this->sys->db->getObject("Content", $id);

		$m = new BHtmlNode("div", "name='dialogQuestion'");
		$f = &$m->appendNode("form", "name='dialogQuestion' action='?cmd=deleteDo&id={$id}&group={$this->group}' method='post'");
		$f->appendNode("h3", "", "Do you really want to delete document {$obj->title} ?");

		$f->appendNode("input", "type='submit' name='arg' value='Delete Document'");
		$f->appendNode("button", "type='button' name='arg' onclick='location.href = \"javascript:history.go(-1)\";'", "Cancel");

		$page = $f->render();
		$page .= "<script language='JavaScript'>document.ws.list = {}; document.ws.list.objId = \"{$obj->id}\";</script>";
		
		return $page;
	}

	function deleteDo($id){
		// Check role
		if(!$this->sys->login->checkLogin("adminDelete") && !$this->sys->login->checkLogin("adminGroup" . $this->group)){
			$this->sys->pageDisplayError(new BError(1, "You are not authorised to delete items. Only users with the 'adminDelete' role can perform this."));
			exit();
		}

		if($id == "undefined"){
			$this->sys->pageDisplayError(new BError(1, "No object selected"));
			return;
		}

		$obj = $this->sys->db->getObject("Content", $id);
		contentDelete($obj);

		$page = "";
		$page .= "<h3>Document: {$obj->title} has been Deleted</h3>";	
		$page .= "<script language='JavaScript'>document.ws.list = {}; document.ws.list.objId = \"{$obj->id}\";</script>";
		return $page;
	}
};

function documentList($num=3){
	global	$sys;
	
	if(isset($_GET['group'])){
		$group = filterString($_GET['group']);
		$where = "`group`='{$group}'";
	}
	else{
		$group = "";
		$where = "";
	}

//	$objList = $sys->db->getObjectList("Content", "", $where, "!dateModified", "3");
	$objList = $sys->db->getObjectList("Content", "", $where, "!dateCreated", $num);

	$html = new BHtmlNode("div", "id='news'");
	$html->appendNode("a", "href='{$sys->baseUrl}/document?cmd=viewList&group={$group}'")->appendNode("h2", "", "Documents");

	$t = &$html->appendNode("table", "cellspacing='4' cellpadding='4' border=0");
	foreach($objList as $obj){
		$r = &$t->appendNode("tr");
		if($obj->dateModified == "")
			$r->appendNode("th", "", dateString($obj->dateCreated));
		else
			$r->appendNode("th", "", dateString($obj->dateModified));
		$r->appendNode("td", "", $obj->category);
		$r->appendNode("td")->appendNode("a", "href='/document?cmd=view&id={$obj->id}'", $obj->title);
	}

	return $html->render();
}
?>
