<?php
require_once "BModule.php";
require_once "BBlock.php";
require_once "BView.php";
require_once "BEdit.php";
require_once "content/content.php";

function addDocumentItem($table, $icon, $title, $href){
	global	$sys;
	
	$r = &$table->appendNode("tr");
	$c = &$r->appendNode("td");
	$o = &$c->appendNode("a", "href='{$href}'");
	$o->appendNode("img", "src='{$sys->baseUrl}/icons/misc/{$icon}'");
	$c = &$r->appendNode("td");
	$c->appendNode("a", "href='{$href}'", $title);
}

class ViewSettings {
	function __construct(){
	}
	
	function getCategory(){
		if(isset($_GET["category"])){
			return filterString($_GET["category"]);
		}
		else {
			return "all";
		}
	}
	
	function getHtml(){
		$title = "";
		$args = array_merge(array("all"), categoryGetList("content"));
		$value = "";
		if(isset($_GET["group"]))
			$group = filterString($_GET["group"]);
		else
			$group = "";

		
		if(isset($_GET["category"])){
			$value = filterString($_GET["category"]);
		}
		
		$form = new BHtmlNode("form", "method='get'");
		$t = &$form->appendNode("table");
		$r = &$t->appendNode("tr");
		$r->appendNode("td", "", "Categories to list");
		$c = &$r->appendNode("td");

		$sel = &$c->appendNode("select", "name='category' {$title}");
		foreach($args as $item){
			if($item == $value)
				$sel->appendNode("option", "selected='selected'", $item);
			else
				$sel->appendNode("option", "", $item);
		}

		$c = &$r->appendNode("td");
		$c->appendNode("input", "type='submit'");
		$c->appendNode("input", "type='hidden' name='cmd' value='viewList'");
		$c->appendNode("input", "type='hidden' name='group' value='{$group}'");
		return $form->render();
	}
};

class DocumentSchool extends BModule {
	// Basic Interface routines
	function __construct(&$sys){
		parent::__construct($sys);
		$this->name = "document";
		$this->title = "Document";
		$this->info = "Document Admin module";
		$this->group = "";

		// Add HTML functions
		$this->sys->htmlFuncs[] = "documentList";
	}
	
	function checkAccess(){
		return $this->sys->login->checkLogin("admin") || $this->sys->login->checkLogin("adminGroup" . $this->group);
	}

	// Admin Interface
	function getMenu(){
		return new BMenu("Documents", "/{$this->name}", "", array("Document List" => "/{$this->name}", "Document Add" => "/{$this->name}?cmd=add"));
	}

	function getPage($uri){
		$this->parseUri($uri);

//		print "Uri: '{$this->uri}'</br>";

		if($this->checkAccess()){
			switch($this->cmd){
			case "viewMain":		return $this->viewMain();		break;
			case "viewList":		return $this->editList();		break;

			case "view":			return $this->view();			break;
			case "uploadNew":		return $this->uploadNew();		break;
			case "uploadNewVersion":	return $this->uploadNewVersion(filterToInt($_GET["id"]));	break;
			case "uploadNewsletter":	return $this->uploadNewsletter();	break;
			case "edit":			return $this->edit(filterToInt($_GET["id"]));	break;
			case "save":			return $this->save();			break;
			case "delete":			return $this->delete(filterToInt($_GET["id"]));	break;
			case "deleteDo":		return $this->deleteDo(filterToInt($_GET["id"]));	break;
			case "convertToPdf":		return $this->convertToPdf();		break;
			case "convertAllToPdf":		return $this->convertAllToPdf();	break;
			default: 			return $this->viewMain();		break;
			}
		}
		else {
			switch($this->cmd){
			case "view":			return $this->view();			break;
			case "viewList":		return $this->viewList();		break;
			default: 			return $this->viewMain();		break;
			}
		}
	}

	function getPageBlock($uri){
		if($this->checkAccess()){
			$o = new BMenu("Documents", "", "", array(
				new BMenu("List", "", "href='?cmd=viewList&group={$this->group}'"),
				new BMenu("", "", ""),
				new BMenu("View", "", "onmouseover='this.href = \"?cmd=view&group={$this->group}&id=\" + document.ws.list.objId'"),
				new BMenu("Upload New", "", "onmouseover='this.href = \"?cmd=uploadNew&group={$this->group}\"'"),
				new BMenu("Upload New Version", "", "onmouseover='this.href = \"?cmd=uploadNewVersion&group={$this->group}&id=\" + document.ws.list.objId'"),
				new BMenu("Edit Information", "", "onmouseover='this.href = \"?cmd=edit&group={$this->group}&id=\" + document.ws.list.objId'"),
				new BMenu("Delete", "", "onmouseover='this.href = \"?cmd=delete&group={$this->group}&id=\" + document.ws.list.objId'"),
				new BMenu("", "", ""),
				new BMenu("Upload Newsletter", "", "href='?cmd=uploadNewsletter&group={$this->group}'"),
				new BMenu("Convert to PDF", "", "onmouseover='this.href = \"?cmd=convertToPdf&group={$this->group}&id=\" + document.ws.list.objId'"),
				new BMenu("Convert All to PDF", "", "href='?cmd=convertAllToPdf'"),
				));
			return $o;
		}
		else {
			return Null;
		}
	}


	function viewMain(){
		$page = "<h1>School Documents</h1>";
		
		$t = new BHtmlNode("table");

		addDocumentItem($t, "newsLetter.gif", "Latest Newsletter", "{$this->sys->baseUrl}/document?cmd=view&title=Newsletter");
		addDocumentItem($t, "prospectus.gif", "School Prospectus", "{$this->sys->baseUrl}/document?cmd=view&title=Prospectus");
		addDocumentItem($t, "prospectus.gif", "Publication Scheme", "{$this->sys->baseUrl}/document?cmd=view&title=Publication Scheme");
		addDocumentItem($t, "prospectus.gif", "Instrument of Government", "{$this->sys->baseUrl}/document?cmd=view&title=Instrument of Government");
		addDocumentItem($t, "folder.gif", "School Policies", "{$this->sys->baseUrl}/document?cmd=viewList&category=policy");
		addDocumentItem($t, "folder.gif", "All Documents", "{$this->sys->baseUrl}/document?cmd=viewList");

		$page .= $t->render();

		return $page;
	}

	function viewList(){
		$page = "<h1>Documents</h1>";

		$settings = new ViewSettings();
		$page = $page . $settings->getHtml() . "<br>";

		if($this->group)
			$where = "`group`='" . dbEscapeString($this->group) . "'";
		else
			$where = "";

		$category = dbEscapeString($settings->getCategory());
		if($category != "all"){
			if($where)
				$where .= " and ";
			$where .= "`category` = '{$category}' and row (title, version) in ( select title, max(version) from sch0_Content group by title)";
		}
		else {
			if($where)
				$where .= " and ";
			$where .= "row (title, version) in ( select title, max(version) from sch0_Content group by title)";
		}

		$view = new BViewDatabase("documents");
		$view->setView(array(
			new BViewType("id", "Id"),
			new BViewType("title", "Title"),
			new BViewType("category", "Category"),
			new BViewType("group", "Group"),
			new BViewType("version", "Version"),
			new BViewType("dateCreated", "Date Created", "date"),
			new BViewType("pdf", "PDF", "link", array("PDF", "?cmd=view&type=pdf&id={\$obj->id}")),
//			new BViewType("html", "Html", "link", array("HTML", "?cmd=view&type=html&id={\$obj->id}")),
			new BViewType("master", "Master", "link", array("Master", "?cmd=view&type=master&id={\$obj->id}"))));


		$view->setSelection($where);

		if(!$view->order)
			$view->setOrder("category,title,!version");

		$view->setTable("Content");

//		select * from sch0_Content where row (title, version) in ( select title, max(version) from sch0_Content group by title) order by id;
		
		
		$page = $page . $view->getHtml();

		return $page;
	}

	function editList(){
		$page = "<h3>Documents</h3>";

		$settings = new ViewSettings();
		$page = $page . $settings->getHtml() . "<br>";

		if($this->group)
			$where = "`group`='" . dbEscapeString($this->group) . "'";
		else
			$where = "";

		$category = dbEscapeString($settings->getCategory());
		if($category != "all"){
			if($where)
				$where .= " and ";
			$where .= "`category` = '{$category}' and row (title, version) in ( select title, max(version) from sch0_Content group by title)";
		}
		else {
			if($where)
				$where .= " and ";
			$where .= "row (title, version) in ( select title, max(version) from sch0_Content group by title)";
		}

		$view = new BViewDatabase("list", "select");
		$view->setView(array(
			new BViewType("id", "Id"),
			new BViewType("type", "Type"),
			new BViewType("title", "Title"),
			new BViewType("version", "Version"),
			new BViewType("category", "Category"),
			new BViewType("group", "Group"),
			new BViewType("description", "Description"),
			new BViewType("dateCreated", "Date Created", "date"),
			new BViewType("pdf", "PDF", "link", array("PDF", "?cmd=view&type=pdf&id={\$obj->id}")),
//			new BViewType("html", "Html", "link", array("HTML", "?cmd=view&type=html&id={\$obj->id}")),
			new BViewType("master", "Master", "link", array("Master", "?cmd=view&type=master&id={\$obj->id}"))));

		$view->setSelection($where);

		if(!$view->order)
			$view->setOrder("category,title,!version");

		$view->setTable("Content");
		$page = $page . $view->getHtml();

		return $page;
	}
	
	function view(){
//		$id = filterToInt($_GET["id"]);
//		print "View Document: Type: {$_GET["type"]} Id: {$_GET["id"]} Id: {$id}<br>";

		if(isset($_GET["title"])){
			$obj = contentGetObjTitled(dbEscapeString($_GET["title"]));
		}
		else {
			$obj = contentGetObj(filterToInt($_GET["id"]));
		}

		if(isset($_GET["type"]))
			$type = filterString($_GET["type"]);
		else
			$type = "pdf";
		
		if($type == "master")
			$type = $obj->type;

		return contentView("Documents", $obj, $type);
	}
	
	function edit($arg){
		$page = "<h2>Edit Document</h2>";

		if($arg == "undefined"){
			$this->sys->pageDisplayError(new BError(1, "No object selected"));
			return "";
		}
		else if(is_object($arg)){
			$obj = $arg;
		}
		else if($arg == 0){
			$obj = $this->sys->db->getNewObject("Content");
			$obj->version = 0;
			$obj->group = $this->group;
			$obj->dateCreated = strftime("%Y-%m-%d");
		}
		else {
			$obj = $this->sys->db->getObject("Content", $arg);
		}


		$obj->MAX_FILE_SIZE = (8*1024*1024);
		$obj->fileName = "";

		$view = new BEditObj("fileUpload", "Document Upload", "?cmd=save&group={$this->group}", "");
		$view->setView(array(
			new BViewType("id", "", "hidden"),
			new BViewType("type", "", "hidden"),
			new BViewType("version", "", "hidden"),
			new BViewType("filePath", "", "hidden"),
			new BViewType("MAX_FILE_SIZE", "", "hidden"),
			new BViewType("title", "", "text", "", 400, 0),
			new BViewType("category", "", "select", categoryGetList("content")),
			new BViewType("group", "Group", "select", array_merge(array(""), $this->sys->groups)),
			new BViewType("description", "", "textarea", "", 400, 100),
			new BViewType("dateCreated", "Date Created", "date"),
			new BViewType("fileName", "", "file", "", 400, 0),
			new BViewType("sendEmail", "SendEmail", "checkbox"),
			));

		$view->setHelp("title", "Enter the title.");
		$view->setHelp("category", "Enter the category by selecting one from the list.");
		$view->setHelp("description", "Optionaly enter a description. This can be multiple lines long and contain web addresses etc");
		$view->setHelp("fileName", "Enter a local file name. You can use the Browse button to use a file selector dialog");
		$view->setHelp("sendEmail", "If checked will send an email to all users.");

		$view->setObj($obj);
		
		$page .= $view->getHtml();
		$page .= "<p>The document system supports the file types: pdf,doc,docx,xlsx,odt,ods,gpx.</p>";
		$page .= "<p>If a non PDF file is uploaded the system will attempt to convert it into pdf format.</p>";

		return $page;
	}
	
	function uploadNew(){
		return $this->edit("0");
	}

	function uploadNewVersion($id){
		if($id == "undefined"){
			$this->sys->pageDisplayError(new BError(1, "No object selected"));
			return;
		}
		else {
			$obj = contentGetObj($id);
			$obj->id = 0;
			$obj->dateCreated = strftime("%Y-%m-%d");
			$obj->MAX_FILE_SIZE = (8*1024*1024);
			$obj->fileName = "";

			$f = new BEditObj("fileUpload", "Document Upload", "?cmd=save&group={$this->group}", "");
			$f->setSaveButtonTitle("Upload Document");
			$f->setView(array(
				new BViewType("id", "", "hidden"),
				new BViewType("type", "", "hidden"),
				new BViewType("version", "", "hidden"),
				new BViewType("filePath", "", "hidden"),
				new BViewType("MAX_FILE_SIZE", "", "hidden"),
				new BViewType("title", "", "text", "", 400, 0),
				new BViewType("category", "", "select", categoryGetList("content")),
				new BViewType("group", "Group", "select", array_merge(array(""), $this->sys->groups)),
				new BViewType("description", "", "textarea", "", 400, 100),
				new BViewType("dateCreated", "Date Created", "date"),
				new BViewType("fileName", "", "file", "", 400, 0),
				new BViewType("sendEmail", "SendEmail", "checkbox"),
				));

			$f->setHelp("title", "Enter the title.");
			$f->setHelp("category", "Enter the category by selecting one from the list.");
			$f->setHelp("description", "Optionaly enter a description. This can be multiple lines long and contain web addresses etc");
			$f->setHelp("fileName", "Enter a local file name. You can use the Browse button to use a file selector dialog");
			$f->setHelp("sendEmail", "If checked will send an email to all users.");

			$f->setObj($obj);

			$page = $f->getHtml();
			$page .= "<p>The document system supports the file types: pdf,doc,docx,xlsx,odt,ods,gpx.</p>";
			$page .= "<p>If a non PDF file is uploaded the system will attempt to convert it into pdf format.</p>";

			$this->sys->pageDisplay("Documents", $page);
		}
	}

	function uploadNewsletter(){
		$obj = contentGetObjTitled("Newsletter");
//		print "Newsletter {$obj->id}Ver: {$obj->version}";
		return $this->uploadNewVersion($obj->id);
	}
	
	
	function save(){
		$page = "";
		$fileType = "";

		unset($_POST['cmd']);
		
		if($_POST['id'] == 0)
			$obj = new BObjContent();
		else
			$obj = $this->sys->db->getObject("Content", $_POST['id']);

		$obj->set($_POST);

		if($err = $obj->validate()){
			$items = implode(",", array_keys($err));
			$this->sys->status = "<span class='editError'>Error in form data in fields: $items</span>";
			return $this->edit($obj);
		}

		if(isset($_FILES["fileName"]) and ($_FILES["fileName"]["name"] != "")){
			$obj->version = $obj->version + 1;
			$pi = pathinfo($_FILES["fileName"]["name"]);
			$obj->fileNameOriginal = $_FILES["fileName"]["name"];
			$obj->type = strtolower($pi['extension']);
		}

		if($obj->filePath == "")
			$obj->filePath = "/files/documents/document-{$obj->id}-{$obj->version}.{$obj->type}";
		
		// Add to database
		if($obj->id){
			$this->sys->db->putObject("Content", $obj);
		}
		else {
			$obj = $this->sys->db->appendObject("Content", $obj);
			$obj->filePath = "/files/documents/document-{$obj->id}-{$obj->version}.{$obj->type}";
			$this->sys->db->putObject("Content", $obj);
		}
		
//		print_r($_FILES);
		if(isset($_FILES["fileName"]) and ($_FILES["fileName"]["name"] != "")){
			$pi = pathinfo($obj->filePath);
			$dir = $this->sys->baseDir . $pi['dirname'];
//			print "Dir: {$dir}<br>";
			
			if(!file_exists($dir))
				mkdir($dir, 0777, 1);
			
			// Move file
			if(!move_uploaded_file($_FILES["fileName"]["tmp_name"], $this->sys->baseDir . $obj->filePath))
				$page .= "Move Error";
			else {
				$ext = strtolower(pathinfo($obj->filePath, PATHINFO_EXTENSION));
				if($ext != "pdf"){
					$s = $this->sys->baseDir . $obj->filePath;
					$d = $this->sys->baseDir . $pi['dirname'] . "/" . $pi['filename'] . ".pdf";

					emailList("terry@beam.ltd.uk", "Beam: Document Convert", "Document to be converted: {$this->sys->baseUrl}{$obj->filePath} ext: '${ext}'");
					if(0){
						$res = contentConvert($s, $d);

						if($res == False){
							$this->sys->pageDisplayError(new BError(1, "The document could not be converted to PDF at this time, this will happen automatically later."));
							exit();
						}
					}
					else {
						runBackground($this->sys->baseUrl . "/content?cmd=contentConvert&id=$obj->id"); 
					}
				}
			}
		}

		if(isset($_POST['sendEmail']) && ($_POST['sendEmail'] == "1")){
			emailAll("{$this->sys->siteName}: News: {$obj->title}", "A new school Document: {$obj->title} is available at: {$this->sys->baseUrl}/document?cmd=view&id={$obj->id}");
		}

		$page .= "<h3>Document has been saved</h3>";

		return $page;
	}
	
	function convertToPdf(){
		$id = filterToInt($_GET["id"]);

//		$res = $this->sys->modules["content"]->contentConvert("");
//		print("Result: $res<br>");
		runBackground($this->sys->baseUrl . "/content?cmd=contentConvert&id={$id}"); 

		return "Converting document ID: {$id} to PDF.";
	}
	function convertAllToPdf(){
		$page = "Convert all documents to PDF<br>";

		$data = array(0);
		for($pos = 0; count($data); $pos += 100){
			$data = $this->sys->db->getObjectList("Content", "", "", "", "{$pos},100");

			foreach($data as $obj){
				if(file_exists(filePathAbs($obj->filePath))){
					// Ignore some
					if(!in_array(strtolower($obj->type), array("pdf", "jpg", "png", "gif"))){
						// Check if has PDF
						if(in_array(strtolower($obj->type), array("doc", "docx", "odt", "ods", "pptx", "pub", "xls", "ppt", "pptx", "wps"))){
							$pi = pathinfo($obj->filePath);
							$pdfFile = $pi['dirname'] . "/" . $pi['filename'] . ".pdf";

							if(!file_exists(filePathAbs($pdfFile)) || (filesize(filePathAbs($pdfFile)) == 0)){
								$filesize = filesize(filePathAbs($pdfFile));
								$page .= "Do: {$obj->id} {$obj->title} {$obj->type} {$obj->filePath} {$pdfFile} {$filesize}<br>";
								contentConvert(filePathAbs($obj->filePath), filePathAbs($pdfFile));
							}
						}
						else {
							$page .= "CannotPdf: {$obj->id} {$obj->title} {$obj->type} {$obj->filePath} {$info}<br>";
						}
					}
				}
				else {
					$page .= "NoFile: {$obj->id} {$obj->title} {$obj->type} {$obj->filePath} {$info}<br>";
					$this->sys->db->deleteObject("Content", $obj->id);
				}
			}
		}

		return $page;
	}
	

	function delete($id){
		// Check role
		if(!$this->sys->login->checkLogin("adminDelete")){
			$this->sys->pageDisplayError(new BError(1, "You are not authorised to delete items. Only users with the 'adminDelete' role can perform this."));
			exit();
		}

		if($id == "undefined"){
			$this->sys->pageDisplayError(new BError(1, "No object selected"));
			return;
		}

		$obj = $this->sys->db->getObject("Content", $id);

		$m = new BHtmlNode("div", "name='dialogQuestion'");
		$f = &$m->appendNode("form", "name='dialogQuestion' action='?cmd=deleteDo&id={$id}' method='post'");
		$f->appendNode("h3", "", "Do you really want to delete document {$obj->title} ?");

		$f->appendNode("input", "type='submit' name='arg' value='Delete Document'");
		$f->appendNode("button", "type='button' name='arg' onclick='location.href = \"javascript:history.go(-1)\";'", "Cancel");

		$page = $f->render();
		$page .= "<script language='JavaScript'>document.ws.list = {}; document.ws.list.objId = \"{$obj->id}\";</script>";
		
		return $page;
	}

	function deleteDo($id){
		// Check role
		if(!$this->sys->login->checkLogin("adminDelete")){
			$this->sys->pageDisplayError(new BError(1, "You are not authorised to delete items. Only users with the 'adminDelete' role can perform this."));
			exit();
		}

		if($id == "undefined"){
			$this->sys->pageDisplayError(new BError(1, "No object selected"));
			return;
		}

		$obj = $this->sys->db->getObject("Content", $id);
		contentDelete($obj);

		$page = "";
		$page .= "<h3>Document: {$obj->title} has been Deleted</h3>";	
		$page .= "<script language='JavaScript'>document.ws.list = {}; document.ws.list.objId = \"{$obj->id}\";</script>";
		return $page;
	}
};

function documentList(){
	global	$sys;

	if(isset($_GET['group'])){
		$group = filterString($_GET['group']);
		$where = "`group`='{$group}'";
	}
	else{
		$group = "";
		$where = "";
	}

//	$objList = $sys->db->getObjectList("Content", "", $where, "!dateModified", "3");
	$objList = $sys->db->getObjectList("Content", "", $where, "!dateCreated", "3");

	$html = new BHtmlNode("div", "id='news'");
	$html->appendNode("a", "href='{$sys->baseUrl}/document?cmd=viewList&group={$group}'")->appendNode("h2", "", "Documents");

	$t = &$html->appendNode("table", "cellspacing='4' cellpadding='4' border=0");
	foreach($objList as $obj){
		$r = &$t->appendNode("tr");
		if($obj->dateModified == "")
			$r->appendNode("th", "", dateString($obj->dateCreated));
		else
			$r->appendNode("th", "", dateString($obj->dateModified));
		$r->appendNode("td", "", $obj->category);
		$r->appendNode("td")->appendNode("a", "href='/document?cmd=view&id={$obj->id}'", $obj->title);
	}

	return $html->render();
}

?>
