<?php
/*******************************************************************************
 *	EventBookingForm.php	BookingForm Module
 *				T.Barnaby,	BEAM Ltd,	2011-12-09
 *******************************************************************************
 */
require_once "BModule.php";
require_once "BBlock.php";
require_once "BView.php";
require_once "BDate.php";
require_once "BEdit.php";
require_once "BDate.php";

global	$sys;
$sys->db->addObjectClasses(array("EventBookingTci2012" => "BObjEventBooking"));

class BObjEventBooking extends BObj {
	function __construct(){
		$m = array();

		$m[] = new BMember("id", "Int", "Number");
		$m[] = new BMember("deleted", "Int", "Number");

		for($n = 0; $n < 6; $n++){
			$m[] = new BMember("name{$n}", "String");
			$m[] = new BMember("sex{$n}", "Int");
			$m[] = new BMember("dateOfBirth{$n}", "Date", "date", array('format' => '%Y-%n-%j'));
			$m[] = new BMember("age{$n}", "Int");
		}
		
		$m[] = new BMember("member", "String");
		$m[] = new BMember("address", "String");
		$m[] = new BMember("postcode", "String");
		$m[] = new BMember("email", "String");
		$m[] = new BMember("telephone", "String");
		$m[] = new BMember("mobileTelephone", "String");
		$m[] = new BMember("arrivalDate", "Date");
		$m[] = new BMember("departureDate", "Date");
		$m[] = new BMember("accommodation", "String");
		$m[] = new BMember("currency", "String");
		$m[] = new BMember("help", "String");
		$m[] = new BMember("notes", "String");

		$m[] = new BMember("adults", "Int");
		$m[] = new BMember("children", "Int");
		$m[] = new BMember("infants", "Int");
		$m[] = new BMember("campingAdults", "Int");
		$m[] = new BMember("campingChildren", "Int");

		for($n = 0; $n < 4; $n++){
			$m[] = new BMember("q{$n}", "Int");
			$m[] = new BMember("e{$n}", "Float");
			$m[] = new BMember("t{$n}", "Float");
		}
		$m[] = new BMember("total", "Float");
		$m[] = new BMember("discount", "Float");
		$m[] = new BMember("paid", "Float");

		$m[] = new BMember("addedDate", "Date");
		$m[] = new BMember("addedUserName", "String");

		parent::__construct($m);
	}

	function dbTableFields(){
		$s = "(`id` int NOT NULL auto_increment,";
		$s .= "`deleted` int default 0,";
		
		for($n = 0; $n < 6; $n++){
			$s .= "`name{$n}` text,";
			$s .= "`sex{$n}` int,";
			$s .= "`dateOfBirth{$n}` date,";
			$s .= "`age{$n}` int,";
		}

		$s .= "`member` text,";
		$s .= "`address` text,";
		$s .= "`postcode` text,";
		$s .= "`email` text,";
		$s .= "`telephone` text,";
		$s .= "`mobileTelephone` text,";
		$s .= "`arrivalDate` date,";
		$s .= "`departureDate` date,";
		$s .= "`accommodation` text,";
		$s .= "`currency` text,";
		$s .= "`help` text,";
		$s .= "`notes` text,";

		$s .= "`adults` int,";
		$s .= "`children` int,";
		$s .= "`infants` int,";
		$s .= "`campingAdults` int,";
		$s .= "`campingChildren` int,";

		for($n = 0; $n < 4; $n++){
			$s .= "`q{$n}` float,";
			$s .= "`e{$n}` float,";
			$s .= "`t{$n}` float,";
		}
		$s .= "`total` float,";
		$s .= "`discount` float,";
		$s .= "`paid` float,";

		$s .= "`addedDate` text,";
		$s .= "`addedUserName` text,";
		$s .= "PRIMARY KEY  (`id`))";

		return $s;
	}
};

function formAdd($h, $name, $type, $value = "", $style="", $args = Null){
	global	$sys;

	switch($type){
	case 'select':
		$sel = &$h->appendNode("select", "name='$name'");
		foreach($args as $a){
			if($a == $value)
				$sel->appendNode("option", "selected='selected'", $a);
			else
				$sel->appendNode("option", "", $a);
		}
		break;
	case 'checkbox':
		if($value == "1")
			$h->appendNode("input", "type='checkbox' name='{$name}_checkbox' value='$value' checked onchange='if(this.checked) document.getElementById(\"{$name}\").value = 1; else document.getElementById(\"{$name}\").value = 0;'");
		else
			$h->appendNode("input", "type='checkbox' name='{$name}_checkbox'' value='$value' onchange='if(this.checked) document.getElementById(\"{$name}\").value = 1; else document.getElementById(\"{$name}\").value = 0;'");
		$h->appendNode("input", "type='hidden' id='{$name}' name='$name' value='$value'");
		break;
	case 'date':
		$h->appendNode("script", "", "editorDate('', '$name', '$value', '');");
		break;
	case 'textarea':
		$h->appendNode("textarea", "name='$name' style='{$style}'", $value);
		break;
	case 'textareaHtml':
		$oFCKeditor = new FCKeditor($name);
		$oFCKeditor->BasePath	= $sys->baseUrl . "/lib/fckeditor/";
		$oFCKeditor->Config['CustomConfigurationsPath'] = $sys->baseUrl . "/lib/javascript/fckeditor-textfield.config.js";
		$oFCKeditor->Config['BaseHref'] = $sys->baseUrl . "/" ;
		if(isset($args["width"])){
			$oFCKeditor->Width	= $args["width"];
		}
		if(isset($args["height"])){
			$oFCKeditor->Height	= $args["height"];
		}
		$oFCKeditor->ToolbarSet	= "BeamBasic";
		$oFCKeditor->Value	= $value;

		$h->appendText($oFCKeditor->CreateHtml());
		break;
	case 'file':
		$h->appendNode("input", "type='file' name='$name' value='$value' size=40 style='{$style}'");
		break;
	default:
		$h->appendNode("input", "type='text' name='$name' value='$value' style='{$style}'");
		break;
	}
}

function formAddTable($row, $name, $type, $value = "", $title = "", $style="", $args = Null){
	if($title != "")
		$row->appendNode("th", "align = 'left'", $title);
	$c = $row->appendNode("td");
	formAdd($c, $name, $type, $value, $style, $args);
}

function formAddTableView($row, $name, $type, $value = "", $title = "", $style="", $args = Null){
	if($title != "")
		$row->appendNode("th", "align = 'left'", $title);
	$row->appendNode("td", "style='{$style}'", "{$value}");
	$row->appendNode("input", "type='hidden' id='{$name}' name='$name' value='$value'");
}

function formAddTableRow(&$t, $name, $type, $value = "", $title = "", $style="", $args = Null){
	$row = &$t->appendNode("tr");
	if($title != "")
		$row->appendNode("th", "align = 'left'", $title);
	$c = $row->appendNode("td");
	formAdd($c, $name, $type, $value, $style, $args);
}


function addTableView($row, $name, $type, $value = "", $title = "", $style="", $args = Null){
	if($title != "")
		$row->appendNode("th", "align = 'left'", $title);
	$row->appendNode("td", "style='{$style}'", "{$value}");
}

function addTableRowView(&$t, $name, $type, $value = "", $title = "", $style="", $args = Null){
	$row = &$t->appendNode("tr");
	if($title != "")
		$row->appendNode("th", "align='left'", $title);
	$row->appendNode("td", "style='{$style}'", "{$value}");
}

class Price {
	function __construct($number, $item, $unit){
		$this->number = $number;
		$this->item = $item;
		$this->unit = $unit;
	}
};

class EventBookingForm extends BModule {
	// Basic Interface routines
	function __construct(&$sys){
		parent::__construct($sys);
		$this->name = "eventBookingForm";
		$this->title = "EventBookingForm";
		$this->info = "EventBookingForm module. This module allows the management of booking for an events.";
		$this->eventTitle = "TCI2012";

		$this->bookingStartDate = new BDate("2011-12-01");
		$this->bookingEndDate = new BDate("2011-12-23");
		$this->eventStartDate = new BDate("2012-06-02");
		$this->eventEndDate = new BDate("2012-06-09");
		
		$this->prices = array();
		$this->prices[] = new Price(0, "Rally fee adult (18+)", "Per adult");
		$this->prices[] = new Price(1, "Pitch fee (2 people and electrics)", "Per pitch per night");
		$this->prices[] = new Price(2, "Pitch: Additional adults (7+)", "Per person per night");
		$this->prices[] = new Price(3, "Pitch: Additional children (2-6)", "Per person per night");
	}

	function checkAccess(){
		return $this->sys->login->checkLogin("admin");
	}
		
	function getMenu(){
		if($this->checkAccess()){
			return Null;
		}
		else {
			return Null;
		}
	}

	function getPage($uri){
		$this->parseUri($uri);

		if(0){
			printf("Uri: %s<br>\n", $uri);
			print("Get: "); print_r($_GET); print("<br>\n");
			print("Post: "); print_r($_POST); print("<br>\n");
		}

		// Check if before booking start date
		$dateNow = new BDate("now");

		if(! $this->checkAccess()){
			if($dateNow->timeStamp < $this->bookingStartDate->timeStamp){
				$str = "<center><H2>Bookings for this event are not open yet</H2></center>";
				$str .= "<center><H2>Sorry for any inconvenience</H2></center>";
				return $str;
			}
			if($dateNow->timeStamp > $this->bookingEndDate->timeStamp){
				$str = "<center><H2>Bookings for this event are now closed</H2></center>";
				$str .= "<center><H2>Sorry for any inconvenience</H2></center>";
				return $str;
			}
		}

		if(isset($_POST["buttonBook"])){
			$obj = new BObjEventBooking();
			$obj->set($_POST);
			
			$editing = 0;
			if($obj->id == 0){
				$obj->addedDate = strftime("%Y-%m-%d");
				$obj->addedUserName = $this->sys->user->name;
			}
			else {
				$editing = 1;
			}

/*			
			if($err = $obj->validate()){
				$items = implode(",", array_keys($err));
				$this->sys->status = "<span class='editError'>Error in form data in fields: $items</span>";
				return $this->edit($obj);
			}
*/
//			BDatabase::$debug = 1;
			if($obj->id)
				$this->sys->db->putObject("EventBookingTci2012", $obj);
			else
				$obj = $this->sys->db->appendObject("EventBookingTci2012", $obj);

			$h = new BHtmlNode("h2", "style='text-align: center;'", "Thank you, {$obj->name0}, your Booking for {$this->eventTitle} has been accepted");
			$h->appendNode("h2", "style='text-align: center;'", "Your BookingRef is: {$obj->id}");
			if($obj->accommodation == "Chalet")
				$h->appendNode("h2", "style='text-align: center;'", "Note: Chalet accommodation has to be arranged with the campside by yourself and paid directly to them, there is an email address listed in the event information.");
			else if($obj->accommodation == "Campling-ACSI")
				$h->appendNode("h2", "style='text-align: center;'", "Note: Campling-ACSI accommodation has to be arranged with the campside by yourself and paid directly to them, there is an email address listed in the event information.");
			$h->appendNode("h2", "style='text-align: center;'", "An email has been sent confirming this booking, with a copy of your booking form that you can print");
			$h->appendNode("h2", "style='text-align: center;'", "We hope you enjoy the event");
			$h->appendNode("h2", "style='text-align: center;'", "Happy Tandeming !");
			
			$h->appendNode("h3", "", "Please pay in one of the following ways, (Please use the reference: \"TCI2012 {BookingRef}\" substituting \"{BookingRef}\" with the booking reference number you have been given)");
			$r = &$h->appendNode("ol");
			$r->appendNode("li", "", "For people in the UK you can pay in pounds sterling using direct bank transfer to the account: Bank: Barclays Bank, AccountName: The Tandem Club, Sortcode: 20-71-03, AccountNumber: 73018431");
			$r->appendNode("li", "", "For people in the UK you can post a cheque in pounds sterling for total amount, with name of Party Leader and BookingRef on the reverse, payable to: \"The Tandem Club\" to: Neil Wheadon, Brook Cottages, High Street, Lower Coleford. BA3 5LS. United Kingdom.");
			$r->appendNode("li", "", "For European bookings pay in euros by direct bank transfer to the following bank account: F.E.R. Oudhof, IBAN: NL58INGB0006385650, BIC: INGBNL2A use the reference \"TCI2012 {Name} \"(Substitute \"{Name}\" with the party leaders surname and initials, if they will fit!). For more information contact: Eelco Oudhof, Lichtboei 26 NL-1186 DE Amstelveen, The Netherlands, email: administratie@tandemclub.nl.");
			$r->appendNode("li", "", "International bookings outside Europe pay by direct money transfer to the euros account given above, or in Euro's cash on arrival on the rally site.");
			$h->appendNode("p", "", "If you have any problems with the booking form or system please email: <a href='mailto:tci2012@events.tandem-club.org.uk'>tci2012@events.tandem-club.org.uk</a>");
			
			$page = $h->render();
			$page .= $this->view($obj);
			
			if($editing == 0){
				// Send an email
				$h = new BHtmlNode("html");
				$b = &$h->appendNode("head");
				$b = &$h->appendNode("body", "style='background-color: #CCDDDD;'");
				$b->appendNode("style", "type='text/css'", "table { empty-cells: show; }");
				$b->appendText($page);
				sendEmailTo($obj->email, "{$this->sys->siteTitle}: Event booking: {$obj->id}", $h->render(), 1);
			}
		}
		else {
			$page = "";
			$page .= $this->header();
			$page .= $this->form(0);
		}

		return $page;
	}

	function getPageBlock($uri){
		if($this->checkAccess()){
			$help = $this->sys->baseUrl . "/modules/info/info.html";
			$o = new BMenu("BookingForm", "", "", array(
				new BMenu("Help", "", "href='?cmd=help'"),
				));
		}
		else {
			$o = Null;
		}
		return $o;
	}

	function parseUri($uri){
		$this->event = "";
		$this->eventArg = "";

		if(strpos($uri, "/")){
			$this->event = substr($uri, strpos($uri, "/") + 1);
			if(strpos($this->event, "/")){
				$this->eventArg = substr($this->event, strpos($this->event, "/") + 1);
				$this->event = substr($this->event, 0, strpos($this->event, "/") + 1);
			}
		}
	}
	
	function header(){
		$text = <<< End_Of_Text
<h1 style="text-align: center;">The Tandem Club International Rally 2012</h1>
<h3 style="text-align: center;">Château de Lez-Eaux, Saint-Aubin des Préaux, 50380 Saint Pair sur mer, Manche, France</h2>
<h2 style="text-align: center;">Saturday, 2nd. June 2012 - Saturday, 9th. June 2012</h2>
<h1 style="text-align: center;">Booking Form</h1>
<h4 style="text-align: center;">Bookings to be received by Sunday 29th. April 2012</h4>

<h3>Important Notes</h3>
<ul>
<li>This event is open to UK or overseas Tandem Club Members or, in the case of overseas people, members of the following organisations:
"Tandem Club of America", "Tandem Club de France", "Tandem Club NL (Netherlands)", "Tandem ClubVlaanderen (Belgium)" and "Tandem-fahren.de (Germany)".
You can join the Tandem Club using the forms on the TC website. <a href='http://www.tandem-club.org.uk/_subscriptiondetails.htm'>Joining the TC</a> (About 10 UKP per year)    </li>
<li>All bookings to be received by Rally organisers by: Sunday 29th. April 2012. Subject to number of available pitches.</li>
<li>Child rates quoted apply to those between 2 and 6 inclusive on 2/06/2012.</li>
<li>Infant rates quoted apply to those under 2 on 2/06/2012.</li>
<li>The Rally fee covers the costs incurred in arranging the rally. This includes equipment costs, evening event costs,
Postage and printing of route instructions plus	all the other bits and pieces to make it all happen.</li>
<li>Tandem Club Membership numbers are on the mailing label for your Journal or on any renewal forms. Please enter your cycling clubs name for overseas non TC members.
If you don't know your membership number enter "Unknown" in the membership number box and we will find it for you or email us
at: <a href="mailto:tci2012@events.tandem-club.org.uk">tci2012@events.tandem-club.org.uk</a> so we can find it for you.</li>
<li>Chalet or Campling-ACSI accommodation has to be arranged with the campside by yourself and paid directly to them, there is an email address listed in the event information. Please use the "Chalet" or "Campling-ACSI" accommodation type for this form.</li>
</ul>
<h3>Booking procedure</h3>
<ol>
<li>Please complete this form and then use the "Calculate" button at the end to calculate the payments.
Make sure you choose the currency type you will be using to pay.</li>
<li>Check the payment values and if Ok use the "Book" button to book for the event. You will be sent
and email with the booking information and will be given a "BookingRef" number.</li>

<li>Please then pay in one of the following ways, (Please use the reference: "TCI2012 {BookingRef}"
substituting "{BookingRef}" with the booking reference number you have been given), they account
number details and address to post checques will be given after you book:<br>
<ul>
<li>For people in the UK you can pay in pounds sterling using direct bank transfer to the Tandem Clubs
account.
<li>For people in the UK you can post a cheque in pounds sterling for total amount, with name of
Party Leader and BookingRef on the reverse, payable to: "The Tandem Club".

<li>For European bookings pay in euros by direct bank transfer to a european bank.

<li>International bookings outside Europe pay by direct money transfer to the euros account given above, or
in Euro's cash on arrival on the rally site.</li> 
</ul>
<li>Note that the TAB key can be used to move to the next field</li>
<li>If you have any problems with the booking form or system please email:
<a href="mailto:tci2012@events.tandem-club.org.uk">tci2012@events.tandem-club.org.uk</a></li>
</ol>
End_Of_Text;

		return $text;
	}

	function setDataFromPost(&$booking){
		// Sets the data from POST info
		foreach($booking as $k => $v){
			if(isset($_POST[$k])){
				$booking->$k = $_POST[$k];
			}
		}
	}

	function calculate(&$booking){
		$adults = 0;
		$children = 0;
		$infants = 0;
		$campingAdults = 0;
		$campingChildren = 0;
		$camping = 0;
		
		switch($booking->accommodation){
		case "Camping":
		case "Caravan":
		case "MotorHome":
			$camping = 1;
			break;
		}

		if($booking->currency == "Pounds"){
			// Prices in Pounds
			$booking->e0 = 20.00;
			$booking->e1 = 30.00;
			$booking->e2 = 7.50;
			$booking->e3 = 5.50;
		}
		else {
			$booking->e0 = 23.00;
			$booking->e1 = 32.00;
			$booking->e2 = 8.00;
			$booking->e3 = 6.00;
		}

		for($n = 0; $n < 6; $n++){
			if($booking->{"name$n"} != ""){
				$dateOfBirth = new BDate($booking->{"dateOfBirth$n"});
				$age = $this->eventStartDate->getYear() - $dateOfBirth->getYear();
				if($this->eventStartDate->getMonth() < $dateOfBirth->getMonth()){
					$age--;
				}
				else if(($this->eventStartDate->getMonth() == $dateOfBirth->getMonth()) &&
					($this->eventStartDate->getDay() < $dateOfBirth->getDay())){
					$age--;
				}
				$booking->{"age$n"} = $age;
				
//				print("Age: {$age}<br>\n");
				
				if($age > 18){
					$adults++;
				}
				else if($age > 1){
					$children++;
				}
				else {
					$infants++;
				}
		
				if($camping){		
					if($age > 6){
						$campingAdults++;
					}
					else if($age > 1){
						$campingChildren++;
					}
				}
			}
		}
		
		$booking->adults = $adults;
		$booking->children = $children;
		$booking->infants = $infants;
		$booking->campingAdults = $campingAdults;
		$booking->campingChildren = $campingChildren;

		$arrivalDate = new BDate($booking->arrivalDate);
		$departureDate = new BDate($booking->departureDate);
		
		$days = ($departureDate->timeStamp - $arrivalDate->timeStamp) / 86400;
		
		$booking->q0 = $adults;
		$booking->q1 = 0;
		$booking->q2 = 0;
		$booking->q3 = 0;

		switch($booking->accommodation){
		case "Camping":
		case "Caravan":
		case "MotorHome":
			$booking->q1 = $days;
			if($campingAdults > 2){
				$booking->q2 = ($campingAdults - 2) * $days;
				$booking->q3 = $campingChildren * $days;
			}
			else {
				if(($campingAdults + $campingChildren) > 2)
					$booking->q3 = ($campingChildren + $campingAdults - 2) * $days;
			}
			break;
		}
		
		$total = 0;
		for($n = 0; $n < count($this->prices); $n++){
			$booking->{"t$n"} = $booking->{"q$n"} * $booking->{"e$n"};
			$total += $booking->{"t$n"};
		}
		$total = round($total, 2);
		$booking->total = $total;
	}
	
	function validate(&$booking, &$errors){
		$err = 0;
		
		if($booking->name0 == ""){
			$err = 1;
			$errors[] = "We need the party leaders name";
		}
		
		$arrivalDate = new BDate($booking->arrivalDate);
		$departureDate = new BDate($booking->departureDate);
		
		if($arrivalDate->timeStamp < $this->eventStartDate->timeStamp){
			$err = 1;
			$errors[] = "Arrival date before event";
		}
		if($departureDate->timeStamp > $this->eventEndDate->timeStamp){
			$err = 1;
			$errors[] = "Departure date after event";
		}
		
		// Email
		if(!preg_match("/.+@.+/", $booking->email)){
			$err = 1;
			$errors[] = "No email or incorrect email format";
		}
		
		return $err;
	}


	function form($booking){
		$helpSelect = array("None", "Arrival Welcome Desk", "Bar", "Childrens Club", "Games", "Assisting at a Rally Event", "End of Rally Clear up", "Anything");

		$f = new BHtmlNode("form", "id='{$this->name}' name='{$this->name}' enctype='multipart/form-data' action='/events/tci2012/bookingForm#prices' method='post'");

		if($booking == 0){
			$editing = 0;
			$booking = new BObjEventBooking();
			for($n = 0; $n < 6; $n++){
				$booking->{"name$n"} = "";
				$booking->{"sex$n"} = "0";
				$booking->{"dateOfBirth$n"} = "1960-01-01";
			}
			$booking->member = "";
			$booking->address = "";
			$booking->postcode = "";
			$booking->email = "";
			$booking->telephone = "";
			$booking->mobileTelephone = "";
			$booking->arrivalDate = $this->eventStartDate->get();
			$booking->departureDate = $this->eventEndDate->get();
			$booking->accommodation = "";
			$booking->currency = "Pounds";
			$booking->help = "";
			$booking->notes = "";
			for($n = 0; $n < count($this->prices); $n++){
				$booking->{"q$n"} = 0;
				$booking->{"e$n"} = 0;
				$booking->{"t$n"} = 0;
			}
			$booking->total = 0;
			$booking->discount = 0;
			$booking->paid = 0;

//			print("Data: "); print_r($booking); print("<br>\n");
		}
		else {
			$editing = 1;
			// Booking Info
			$f->appendNode("h2", "", "Editing Booking");
			$t = &$f->appendNode("table", "class='BView' cellpadding='2' cellspacing='2' border='1' width='100%'");
			addTableRowView($t, "info0", "text", $booking->name0, "Party Leader", "width:300px;"); 
			addTableRowView($t, "info1", "text", $booking->id, "Booking Id", "width:300px;"); 
			addTableRowView($t, "info2", "text", $booking->addedUserName, "Added By", "width:300px;"); 
			addTableRowView($t, "info3", "text", $booking->addedDate, "Added Date", "width:300px;"); 
		}

		if(isset($_POST["editing"]))
			$editing = $_POST["editing"];
		$this->setDataFromPost($booking);
		$this->calculate($booking);
//		print_r($booking);
		
		$f->appendNode("input", "type='hidden' name='id' value='{$booking->id}'");
		$f->appendNode("input", "type='hidden' name='editing' value='{$editing}'");

		// People
		$f->appendNode("h3", "", "Names of All Attending");
		$t = &$f->appendNode("table", "class='BView' cellpadding='2' cellspacing='2' border='1' width='100%'");

		$r = &$t->appendNode("tr");
		$r->appendNode("th", "", "Item");
		$r->appendNode("th", "", "Name");
		$r->appendNode("th", "", "Male/Female (Male ticked)");
		$r->appendNode("th", "", "Date of Birth");

		for($n = 0; $n < 6; $n++){
			$r = &$t->appendNode("tr");
			if($n == 0)
				$r->appendNode("td", "", "Name " . $n . ": Party Leader");
			else
				$r->appendNode("td", "", "Name " . $n);

			formAddTable($r, "name$n", "text", $booking->{"name$n"}, "", "width: 300px;"); 
			formAddTable($r, "sex$n", "checkbox", $booking->{"sex$n"}, ""); 
			formAddTable($r, "dateOfBirth$n", "date", $booking->{"dateOfBirth$n"}, ""); 
			$r->appendNode("input", "type='hidden' name='age$n' value='{$booking->{"age$n"}}'");
		}
		
		$f->appendNode("h3", "", "General");

		$t = &$f->appendNode("table", "class='BView' cellpadding='2' cellspacing='2' border='1' width='100%'");
		formAddTableRow($t, "member", "text", $booking->member, "TC Membership Number or Other Cycling organisation name", "width:300px;"); 
		formAddTableRow($t, "address", "textarea", $booking->address, "Postal Address", "height:100px; width:400px"); 
		formAddTableRow($t, "postcode", "text", $booking->postcode, "Postcode", "width:300px;"); 
		formAddTableRow($t, "email", "text", $booking->email, "Email Address", "width:300px;"); 
		formAddTableRow($t, "telephone", "text", $booking->telephone, "Telephone (with code)", "width:300px;"); 
		formAddTableRow($t, "mobileTelephone", "text", $booking->mobileTelephone, "Mobile Telephone (with code)", "width:300px;"); 
		formAddTableRow($t, "arrivalDate", "date", $booking->arrivalDate, "Arrival Date", "width:300px;"); 
		formAddTableRow($t, "departureDate", "date", $booking->departureDate, "Departure Date", "width:300px;"); 
		formAddTableRow($t, "accommodation", "select", $booking->accommodation, "Accommodation", "", array("Camping", "Caravan", "MotorHome", "Chalet", "Campling-ACSI", "Off-site")); 
		formAddTableRow($t, "currency", "select", $booking->currency, "Payment Currency", "", array("Pounds", "Euros")); 
		formAddTableRow($t, "help", "select", $booking->help, "Happy to help with", "", $helpSelect); 
		formAddTableRow($t, "notes", "textarea", $booking->notes, "Additional Information", "height:100px; width:400px;"); 

		// Prices
		$f->appendNode("a", "name=prices", "");
		$f->appendNode("h3", "", "Prices");
		$f->appendNode("i", "", "This section is automatically filled in from the above information. Please press the \"Calculate\" button to make sure this is updated.");
		$t = &$f->appendNode("table", "class='BView' cellpadding='2' cellspacing='2' border='1' width='100%'");
		$r = &$t->appendNode("tr");
		$r->appendNode("th", "", "Item");
		$r->appendNode("th", "", "Unit");
		$r->appendNode("th", "", "Quantity");
		$r->appendNode("th", "", "Cost");
		$r->appendNode("th", "", "Total");
		
		for($n = 0; $n < count($this->prices); $n++){
			$price = $this->prices[$n];
			$r = &$t->appendNode("tr");
			$r->appendNode("td", "", $price->item);
			$r->appendNode("td", "", $price->unit);
			formAddTableView($r, "q{$n}", "text", $booking->{"q$n"}, "", "background-color:yellow"); 
			formAddTableView($r, "e{$n}", "text", $booking->{"e$n"}, "", "background-color:yellow"); 
			formAddTableView($r, "t{$n}", "text", $booking->{"t$n"}, "", "background-color:yellow"); 
		}

		$r = &$t->appendNode("tr");
		$r->appendNode("th", "align='left'", "Total");
		$r->appendNode("td", "", "");
		$r->appendNode("td", "", "");
		formAddTableView($r, "currencyDisplay", "text", $booking->currency, "", "background-color:yellow"); 
		formAddTableView($r, "total", "text", $booking->total, "", "background-color:yellow"); 

		if($this->checkAccess()){
			$r = &$t->appendNode("tr");
			$r->appendNode("th", "align='left'", "Discount");
			$r->appendNode("td", "", "");
			$r->appendNode("td", "", "");
			$r->appendNode("td", "", "");
			formAddTable($r, "discount", "text", $booking->discount, "", "background-color:yellow; width:100px;"); 

			$r = &$t->appendNode("tr");
			$r->appendNode("th", "align='left'", "Paid");
			$r->appendNode("td", "", "");
			$r->appendNode("td", "", "");
			$r->appendNode("td", "", "");
			formAddTable($r, "paid", "text", $booking->paid, "", "background-color:yellow; width:100px;"); 
		}
		
		// Add hidden info
		$f->appendNode("input", "type='hidden' name='adults' value='{$booking->adults}'");
		$f->appendNode("input", "type='hidden' name='children' value='{$booking->children}'");
		$f->appendNode("input", "type='hidden' name='infants' value='{$booking->infants}'");
		$f->appendNode("input", "type='hidden' name='campingAdults' value='{$booking->campingAdults}'");
		$f->appendNode("input", "type='hidden' name='campingChildren' value='{$booking->campingChildren}'");
		$f->appendNode("input", "type='hidden' name='addedUserName' value='{$booking->addedUserName}'");
		$f->appendNode("input", "type='hidden' name='addedDate' value='{$booking->addedDate}'");


		// Buttons
		$f->appendNode("h3", "", "Book");
		$r = &$f->appendNode("ul");
		$r->appendNode("li", "", "First use the Calculate button to calculate the cost and validate the booking. Once this has been done please use the Book button.");
		$r->appendNode("li", "", "Please do not use the back button to edit and re-submit once sent. Contact the administrators to change the booking.");
		$r->appendNode("li", "", "Note: Chalet and Campling-ACSI accommodation has to be arranged with the campside by yourself.");
		$r->appendNode("li", "", "Please see the Booking procedure info at the top of this form for details on how to pay.");
		$f->appendNode("p", "", "If you participate in any ride or event organised by the Tandem Club, you do so entirely at your own risk. The club, its officers and ride organisers accept no responsibility for loss, damage to property, accident, injury, or death, that may occur, however caused, whether by negligence, deliberate act or otherwise.");

		$err = 0;		
		if(isset($_POST["buttonCalculate"])){
			$errors = array();
			if($err = $this->validate($booking, $errors)){
				$f->appendNode("h3", "style='color: red'; font-size: 150%;", "There are errors in the form data");
				$r = &$f->appendNode("ul");
				foreach($errors as $e){
					$r->appendNode("li")->appendNode("span", "style='color: red; font-size: 150%;'", $e);
				}
				$f->appendText("Please correct these errors and click on the Calculate button again<br><br>");
			}
		}

		if(($err == 1) || !isset($_POST["buttonCalculate"]))
			$disable = "disabled='disabled'";
		else
			$disable = "";

		$f->appendNode("input", "type='submit' name='buttonCalculate' style='background-color: lightgreen; font-size: 200%;' value='Calculate'");
		$f->appendText("&nbsp;&nbsp;->&nbsp;&nbsp;");
//		$f->appendNode("button", "type='button' name='buttonPrint' $disable style='background-color: lightgreen; font-size: 200%;' onclick='window.print();'", "Print Form");
//		$f->appendText("&nbsp;&nbsp;->&nbsp;&nbsp;");
		if($editing)
			$f->appendNode("input", "type='submit' name='buttonBook' {$disable} style='background-color: lightgreen; font-size: 200%;' value='Save Changes' onclick='this.value=\"Saving, please wait...\";'");
		else
			$f->appendNode("input", "type='submit' name='buttonBook' {$disable} style='background-color: lightgreen; font-size: 200%;' value='Book' onclick='this.value=\"Booking, please wait...\";'");

		return $f->render();
	}

	function view($booking){
		$f = new BHtmlNode("div");
		
		// Booking Info
		$f->appendNode("h3", "", "Booking Info");
		$t = &$f->appendNode("table", "class='BView' cellpadding='2' cellspacing='2' border='1' width='100%'");
		addTableRowView($t, "info0", "text", $booking->name0, "Party Leader", "width:300px;"); 
		addTableRowView($t, "info1", "text", $booking->id, "Booking Id", "width:300px;"); 
		addTableRowView($t, "info2", "text", $booking->addedUserName, "Added By", "width:300px;"); 
		addTableRowView($t, "info3", "text", $booking->addedDate, "Added Date", "width:300px;"); 

		// People
		$f->appendNode("h3", "", "Names of All Attending");
		$t = &$f->appendNode("table", "class='BView' cellpadding='2' cellspacing='2' border='1' width='100%'");

		$r = &$t->appendNode("tr");
		$r->appendNode("th", "", "Item");
		$r->appendNode("th", "", "Name");
		$r->appendNode("th", "", "Male/Female (Male 1)");
		$r->appendNode("th", "", "Date of Birth");

		for($n = 0; $n < 6; $n++){
			$r = &$t->appendNode("tr");
			if($n == 0)
				$r->appendNode("td", "", "Name " . $n . ": Party Leader");
			else
				$r->appendNode("td", "", "Name " . $n);

			addTableView($r, "name$n", "text", $booking->{"name$n"}, "", "width: 300px;"); 
			addTableView($r, "sex$n", "checkbox", $booking->{"sex$n"}, ""); 
			addTableView($r, "dateOfBirth$n", "date", $booking->{"dateOfBirth$n"}, ""); 
		}
		
		$f->appendNode("h3", "", "General");

		$t = &$f->appendNode("table", "class='BView' cellpadding='2' cellspacing='2' border='1' width='100%'");
		addTableRowView($t, "member", "text", $booking->member, "TC Membership Number or Other Cycling organisation name", "width:300px;"); 
		addTableRowView($t, "address", "textarea", $booking->address, "Postal Address", "height:100px; width:400px"); 
		addTableRowView($t, "postcode", "text", $booking->postcode, "Postcode", "width:300px;"); 
		addTableRowView($t, "email", "text", $booking->email, "Email Address", "width:300px;"); 
		addTableRowView($t, "telephone", "text", $booking->telephone, "Telephone (with code)", "width:300px;"); 
		addTableRowView($t, "mobileTelephone", "text", $booking->mobileTelephone, "Mobile Telephone (with code)", "width:300px;"); 
		addTableRowView($t, "arrivalDate", "date", $booking->arrivalDate, "Arrival Date", "width:300px;"); 
		addTableRowView($t, "departureDate", "date", $booking->departureDate, "Departure Date", "width:300px;"); 
		addTableRowView($t, "accommodation", "select", $booking->accommodation, "Accommodation", "", array("Camping", "Caravan", "MotorHome", "Chalet", "Campling-ACSI", "Off-site")); 
		addTableRowView($t, "currency", "select", $booking->currency, "Payment Currency", "", array("Pounds", "Euros")); 
		addTableRowView($t, "help", "select", $booking->help, "Happy to help with", "", $helpSelect); 
		addTableRowView($t, "notes", "textarea", $booking->notes, "Additional Information", "height:100px; width:400px;"); 

		// Prices
		$f->appendNode("h3", "", "Prices");
		$t = &$f->appendNode("table", "class='BView' cellpadding='2' cellspacing='2' border='1' width='100%'");
		$r = &$t->appendNode("tr");
		$r->appendNode("th", "", "Item");
		$r->appendNode("th", "", "Unit");
		$r->appendNode("th", "", "Quantity");
		$r->appendNode("th", "", "Cost");
		$r->appendNode("th", "", "Total");
		
		for($n = 0; $n < count($this->prices); $n++){
			$price = $this->prices[$n];
			$r = &$t->appendNode("tr");
			$r->appendNode("td", "", $price->item);
			$r->appendNode("td", "", $price->unit);
			addTableView($r, "q{$n}", "text", $booking->{"q$n"}, "", "background-color:yellow"); 
			addTableView($r, "e{$n}", "text", $booking->{"e$n"}, "", "background-color:yellow"); 
			addTableView($r, "t{$n}", "text", $booking->{"t$n"}, "", "background-color:yellow"); 
		}

		$r = &$t->appendNode("tr");
		$r->appendNode("th", "align='left'", "Total");
		$r->appendNode("td", "", "");
		$r->appendNode("td", "", "");
		addTableView($r, "currencyDisplay", "text", $booking->currency, "", "background-color:yellow"); 
		addTableView($r, "total", "text", $booking->total, "", "background-color:yellow"); 

		if($this->checkAccess()){
			$r = &$t->appendNode("tr");
			$r->appendNode("th", "align='left'", "Discount");
			$r->appendNode("td", "", "");
			$r->appendNode("td", "", "");
			$r->appendNode("td", "", "");
			addTableView($r, "discount", "text", $booking->discount, "", "background-color:yellow; width:100px;"); 

			$r = &$t->appendNode("tr");
			$r->appendNode("th", "align='left'", "Paid");
			$r->appendNode("td", "", "");
			$r->appendNode("td", "", "");
			$r->appendNode("td", "", "");
			addTableView($r, "paid", "text", $booking->paid, "", "background-color:yellow; width:100px;"); 
		}

		return $f->render();
	}
};
?>
