<?php
/*******************************************************************************
 *	PicturesRandom.php	Random Pictures Module
 *			T.Barnaby,	BEAM Ltd,	2008-05-16
 *******************************************************************************
 */
require_once "BModule.php";
require_once "BBlock.php";
require_once "BHtml.php";


class PicturesRandom extends BModule {
	// Basic Interface routines
	function __construct(&$sys){
		parent::__construct($sys);
		$this->name = "picturesRandom";
		$this->title = "Pictures Random";
		$this->info = "Pictures Random module. This module displays random pictures in the LH area.";

		srand(time());

		// Add HTML functions
		$this->sys->htmlFuncs[] = "picturesRandomImage";
	}

		
	function getMenu(){
		return Null;
	}

	function getPage($uri){
		return Null;
	}

	function getRandomPictureId(){
		// Getlist of picture ID's available
		$l = $this->sys->db->queryObjs("Picture", "select id from {$this->sys->databasePrefix}Picture where `good` = '1'");

		if(count($l)){
			// Select a random pictire		
			$id = $l[rand() % count($l)]->id;
		}
		else {
			$id = 0;
		}

		return $id;
	}

	function getPageBlock($uri){
		$id = $this->getRandomPictureId();

		$obj = $this->sys->db->getObject("Picture", $id);
		
		$showcaseId = intval(substr($obj->category, 9));
		
		$o = new BHtmlNode("div", "");
		$o->appendNode("a", "href='/showcase?cmd=view&amp;id={$showcaseId}'")->appendNode("img", "src='{$this->sys->baseUrl}/files/pictures/picture-{$id}-thumb.jpg' alt='{$obj->title}'");
		$o->appendNode("br", "", $obj->title);
		$o->title = "Pictures";
		$o->type = "HTML";
		
		return $o;
	}
};

function picturesRandomImage($args){
	global	$sys;

	// Getlist of picture ID's available
	$l = $sys->db->queryObjs("Picture", "select id from {$sys->databasePrefix}Picture where `good` = '1'");

	if(count($l)){
		// Select a random pictire		
		$id = $l[rand() % count($l)]->id;
	}
	else {
		$id = 0;
	}

	$obj = $sys->db->getObject("Picture", $id);
	$showcaseId = intval(substr($obj->category, 9));

	$imgArgs = "src='{$sys->baseUrl}/files/pictures/picture-{$id}.jpg'";
	$imgArgs .= " alt='{$obj->title}'";
	$imgArgs .= " " . $args;

	$html = new BHtmlNode("div");
	$html->appendNode("div", "style='float: top;'")->appendNode("a", "href='/showcase?cmd=view&amp;id={$showcaseId}'")->appendNode("img", $imgArgs);
	$html->appendNode("div", "style='float: bottom; text-align: center;'", "<b>{$obj->title}</b>");

	return $html->render();
}
?>
