<?php
/*******************************************************************************
 *	Sms.php	News Module
 *			T.Barnaby,	BEAM Ltd,	2009-06-29
 *******************************************************************************
 *
 * Debug:
 *	Use the news system, tick the sendsTextMessage checkbox.
 *
 *	Test the basic system but don't actualy send the sms:
 *	BSms::testSend = 1;
 *
 *	Test display the XML send and reply
 *	BSms::testMessages = 1;
 *
 *	Test sending to just one mobile number:
 *	Sms::testNumber	= "07980502014";
 *	
 *	
 *	
 *	
 *	
 *	
 *	
 */
require_once "BModule.php";
require_once "BBlock.php";
require_once "BView.php";
require_once "BDate.php";
require_once "BEdit.php";
require_once "BDate.php";


function isdigit($c){
	$ret = 0;
	
	switch($c){
	case "0":
	case "1":
	case "2":
	case "3":
	case "4":
	case "5":
	case "6":
	case "7":
	case "8":
	case "9":
		$ret = 1;
		break;
	default:
		$ret = 0;
	}
	return $ret;
}

function strToHex($string){
	$hex = '';
	for ($i=0; $i < strlen($string); $i++){
		$hex .= "0x" . dechex(ord($string[$i])) . ", ";
	}
	return $hex;
}

class BSms {
	// Basic Interface routines
	function __construct(&$sys){
		$this->sys = $sys;
		$this->url = "http://service.clicksms.co.uk";
		$this->account = $this->sys->smsUser;
		$this->password = $this->sys->smsPassword;
		$this->testSend = 0;
		$this->testMessages = 0;
	}

	function sendMessage($from, $numbers, $message){
		$from = substr($from, 0, 15);
		if(strlen($message) > 157)
			$message = substr($message, 0, 157) . "...";
		
		$xml = "";
		$xml .= "<Msg>\n";
		$xml .= "<Txn>sendsmsmulti</Txn>\n";
		$xml .= "<AccountID>{$this->account}</AccountID>\n";
		$xml .= "<Password>{$this->password}</Password>\n";
		$xml .= "<Message>{$message}</Message>\n";
		$xml .= "<SenderID>{$from}</SenderID>\n";
		$xml .= "<RateCode>1</RateCode>\n";
		$xml .= "<Mobiles>\n";
		foreach($numbers as $number){
			$number = $this->numberClean($number);
			$xml .= "<MobileNo>{$number}</MobileNo>\n";
		}
		$xml .= "</Mobiles>\n";
		$xml .= "</Msg>\n";

		if($this->testSend){
			$l = strlen($message);
			$str = trim($xml);
			print "<xmp>SMS Send: Len: {$l} '{$str}'</xmp><br>\n";
//			$strHex = strToHex($message);
//			print "<xmp>SMS Send: Len: {$l} Hex: '{$strHex}'</xmp><br>\n";
			$result = 0;
		}
		else {
			$result = $this->send(trim($xml), $data);
		}
		
		return $result;
	}
	
	function getCredits(&$num){
		$xml = "";
		$xml .= "<Msg>\n";
		$xml .= "<Txn>getsmscredit</Txn>\n";
		$xml .= "<AccountID>{$this->account}</AccountID>\n";
		$xml .= "<Password>{$this->password}</Password>\n";
		$xml .= "<RateCode>1</RateCode>\n";
		$xml .= "</Msg>\n";

		$result = $this->send(trim($xml), $data);
		
		if(! $result)
			$num = $data["Msg"]["CreditsRemaining"];

		return $result;
	}
	
	function numberClean($n){
		$r = "";
		
		for($i = 0; $i < strlen($n); $i++){
			if(isdigit($n[$i]))
				$r .= $n[$i];
		}
		
		return $r;
	}

	function messageClean($m){
		$r = "";
		
		for($i = 0; $i < strlen($n); $i++){
			if(($n[$i] != "+") and ($n[$i] != " "))
				$r .= $n[$i];
		}
		
		return $r;
	}

	function send($tx, &$rx){
		if($this->testMessages)
			print "<xmp>XML send: '{$tx}'</xmp><br>";
		
		if(1){	
			if($r = $this->xmlSend($tx, $data))
				return $r;
		}
		else {
//			$data = "<Msg><JobId>10190938</JobId><SubmitResult><MobileNo>07980502014</MobileNo><StatusId>0</StatusId><StatusText>Message submitted successfully</StatusText></SubmitResult></Msg>";
			$data = "<Msg><JobId>10190938</JobId><SubmitResult><MobileNo>07980502014</MobileNo><StatusId>9</StatusId><StatusText>Error 1</StatusText></SubmitResult></Msg>";
		}

		if($this->testMessages)
			print "<xmp>XML response: {$r} '{$data}'</xmp><br>";
		
		// Create array from XML
		$xmlParser = new XML();
		$rx = &$xmlParser->parse($data);
		$xmlParser->destruct();

		if($this->testMessages){
			print "<xmp>XML parsed response: ";
			var_dump($rx);
			print "</xmp><br>";
		}
		
		if(isset($rx["Msg"]["SubmitResult"]["StatusId"]) and ($StatusId = intval($rx["Msg"]["SubmitResult"]["StatusId"]))){
			return $this->errorString($StatusId) . ": " . $rx["Msg"]["SubmitResult"]["StatusText"];
		}
		else {
			return 0;
		}
	}
		
		

	function xmlSend($tx, &$rx)
	/*--------------------------------------------------------------------------------*/
	{
		$conn = curl_init(); // initialize curl handle

		curl_setopt($conn, CURLOPT_HTTPHEADER, Array("Content-Type:application/xml")); 
		curl_setopt($conn, CURLOPT_URL,$this->url);
		curl_setopt($conn, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($conn, CURLOPT_TIMEOUT, 4);
		curl_setopt($conn, CURLOPT_POSTFIELDS, $tx);

		$rx = curl_exec($conn);

		curl_close($conn);
		
		// Check to see if a result is returned
		if(!$rx){
			return "Connection Error - There has been an error connecting to the server";
		}
		else{
			return 0;
		}
	}
	
    
	function errorString($num){
		switch($num){
		case 0:
			return "";
			break;
		case 1:
			return 'SMS Error: Missing or badly formatted XML parameter(s).';
			break;
		case 2:
			return 'SMS Error: Missing or badly formatted request value(s).';
			break;
		case 3:
			return 'SMS Error: Invalid account ID/password combination.';
			break;
		case 4:
			return 'SMS Error: Message length too long, greater than 160 characters.';
			break;
		case 5:
			return 'SMS Error: Invalid rate code supplied.';
			break;
		case 8:
			return 'SMS Error: Invalid or badly formatted mobile number.';
			break;
		case 9:
			return 'SMS Error: Insufficient SMS credits available for specified rate code.';
			break;
		case 10:
			return 'SMS Error: Invalid sender id. Max length: 11, [a-z] [A-Z] [0-9], no spaces.';
			break;
		case 11:
			return 'SMS Error: Invalid delivery confirmation indicator.';
			break;
		case 12:
			return 'SMS Error: Reply path required for delivery confirmation.';
			break;
		case 14:
			return 'SMS Error: Invalid or badly formatted URL reply path.';
			break;
		case 15:
			return 'SMS Error: Reply path length too long. Max length 120 characters.';
			break;
		case 16:
			return 'SMS Error: Reply key length too long. Max length 50 characters.';
			break;
		case 20:
			return 'SMS Error: System error! - Contact Click SMS.';
			break;
		case 21:
			return 'SMS Error: System error! - Contact Click SMS.';
			break;
		case 22:
			return 'SMS Error: System error! - Contact Click SMS.';
			break;
		default:
			return 'SMS Error: Unknown error: - Contact Click SMS.';
			break;
		}
	}


	
	// XML_serialize: serializes any PHP data structure into XML
	// Takes one parameter: the data to serialize. Must be an array.
	function xmlSerialise(&$data, $level = 0, $prior_key = NULL){
		if($level == 0)	{
			ob_start();
			echo '<?xml version="1.0" ?>',"\n"; 
		}
		
		while(list($key, $value) = each($data)){
			if(!strpos($key, ' attr')) #if it's not an attribute
				#we don't treat attributes by themselves, so for an empty element
				# that has attributes you still need to set the element to NULL

				if(is_array($value) and array_key_exists(0, $value))
				{
					XML_serialize($value, $level, $key);
				}
				else
				{
					$tag = $prior_key ? $prior_key : $key;
					echo str_repeat("\t", $level),'<',$tag;
					if(array_key_exists("$key attr", $data))
					{ #if there's an attribute for this element
						while(list($attr_name, $attr_value) = each($data["$key attr"]))
							echo ' ',$attr_name,'="',htmlspecialchars($attr_value),'"';
						reset($data["$key attr"]);
					}

					if(is_null($value)) echo " />\n";
					elseif(!is_array($value)) echo '>',htmlspecialchars($value),"</$tag>\n";
					else echo ">\n",XML_serialize($value, $level+1),str_repeat("\t", $level),"</$tag>\n";
				}
		}
		reset($data);
		if($level == 0){
			$str = &ob_get_contents();
			ob_end_clean();
			return $str;
		}
	}
};	

###################################################################################
#
# XML Library, by Keith Devens, version 1.2b
# http://keithdevens.com/software/phpxml
#
# This code is Open Source, released under terms similar to the Artistic License.
# Read the license at http://keithdevens.com/software/license
#
###################################################################################
# XML class: utility class to be used with PHP's XML handling functions
###################################################################################
class XML
{
	var $parser;   #a reference to the XML parser
	var $document; #the entire XML structure built up so far
	var $parent;   #a pointer to the current parent - the parent will be an array
	var $stack;    #a stack of the most recent parent at each nesting level
	var $last_opened_tag; #keeps track of the last tag opened.

	function XML(){
 		$this->parser = &xml_parser_create();
		xml_parser_set_option($this->parser, XML_OPTION_CASE_FOLDING, false);
		xml_set_object($this->parser, $this);
		xml_set_element_handler($this->parser, 'open','close');
		xml_set_character_data_handler($this->parser, 'data');
	}
	function destruct(){ xml_parser_free($this->parser); }
	function parse(&$data){
		$this->document = array();
		$this->stack    = array();
		$this->parent   = &$this->document;
		return xml_parse($this->parser, $data, true) ? $this->document : NULL;
	}
	function open(&$parser, $tag, $attributes){
		$this->data = ''; #stores temporary cdata
		$this->last_opened_tag = $tag;
		if(is_array($this->parent) and array_key_exists($tag,$this->parent)){ #if you've seen this tag before
			if(is_array($this->parent[$tag]) and array_key_exists(0,$this->parent[$tag])){ #if the keys are numeric
				#this is the third or later instance of $tag we've come across
				$key = $this->count_numeric_items($this->parent[$tag]);
			}else{
				#this is the second instance of $tag that we've seen. shift around
				if(array_key_exists("$tag attr",$this->parent)){
					$arr = array('0 attr'=>&$this->parent["$tag attr"], &$this->parent[$tag]);
					unset($this->parent["$tag attr"]);
				}else{
					$arr = array(&$this->parent[$tag]);
				}
				$this->parent[$tag] = &$arr;
				$key = 1;
			}
			$this->parent = &$this->parent[$tag];
		}else{
			$key = $tag;
		}
		if($attributes) $this->parent["$key attr"] = $attributes;
		$this->parent       = &$this->parent[$key];
		$this->stack[]      = &$this->parent;
	}
	function data(&$parser, $data){
		if($this->last_opened_tag != NULL) #you don't need to store whitespace in between tags
			$this->data .= $data;
	}
	function close(&$parser, $tag){
		if($this->last_opened_tag == $tag){
			$this->parent = $this->data;
			$this->last_opened_tag = NULL;
		}
		array_pop($this->stack);
		if($this->stack) $this->parent = &$this->stack[count($this->stack)-1];
	}
  
  
	/*--------------------------------------------------------------------------------*/
	function count_numeric_items(&$array)
	/*--------------------------------------------------------------------------------*/
	{
		return is_array($array) ? count(array_filter(array_keys($array), 'is_numeric')) : 0;
	}
  
}

class BObjSms extends BObj {
	function __construct(){
		parent::__construct(array(
			new BMember("id", "Int", "Number"),
			new BMember("dateAdded", "Date", "date", array('format' => '%Y-%n-%j')),
			new BMember("user", "String"),
			new BMember("number", "Int"),
			new BMember("price", "Float"),
			new BMember("title", "String"),
			new BMember("message", "String"),
			));
	}
};

class Sms extends BModule {
	// Basic Interface routines
	function __construct(&$sys){
		parent::__construct($sys);
		$this->name = "sms";
		$this->title = "Sms";
		$this->info = "Sms module. This module allows the management of SMS items.";
		$this->testNumber = "";
//		$this->testNumber = "07980502014";
		
		// Add Objects
		$this->sys->db->addObjectClasses(array("Sms" => "BObjSms"));

		// Add roles
		$this->sys->modules["user"]->appendRoles(array("smsSend"));
	}

	function checkAccess(){
		return $this->sys->login->checkLogin("smsSend");
	}
		
	function getMenu(){
		if($this->checkAccess()){
			return new BMenu("News", "/{$this->name}", "", array("SMS List" => "/{$this->name}"));
		}
		else {
			return Null;
		}
	}

	function getPage(){
		$this->parseUri($uri);

		if($this->checkAccess()){
			switch($this->cmd){
			default: 			return $this->viewList();		break;
			}
		}
		else {
			return $this->viewList();
		}
	}

	function getPageBlock($uri){
		if($this->checkAccess()){
			$o = new BMenu("Sms", "", "", array(
				new BMenu("List", "", "href='?cmd=viewList'"),
				));
		}
		else {
			$o = Null;
		}
		return $o;
	}

	function viewList(){
		$page = "<h2>SMS information</h2>\n";
		
		$page .= "<b>SMS Credits Available:</b>" . $this->smsAvailable() . "<br><br>\n";

		if($this->checkAccess()){
			$view = new BViewDatabase("sms", "action");
		}
		else {
			$view = new BViewDatabase("sms");
		}
		
		$view->setView(array(
			new BViewType("dateAdded", "Date Sent", "date"),
			new BViewType("user", "User"),
			new BViewType("number", "Number"),
			new BViewType("price", "Price"),
			new BViewType("title", "Message"),
			new BViewType("message", "Message")
			));

		if($view->order == "")
			$view->setOrder("!dateAdded");

		$view->setTable("Sms");
		$page = $page . $view->getHtml();

		return $page;
	}

	function smsNumber(){
		global	$sys;

		// First get list of users who have SMS mobile numbers
		$objList = $sys->db->getObjectList("User", "telephoneMobile", "`telephoneMobile` != ''", "");
		
		return count($objList);
	}

	function smsCost($message){
		global	$sys;

		return $this->smsNumber() * $sys->smsCost;
	}

	function smsAvailable(){
		global	$sys;

		$available = 0;

		$sms = new BSms($this->sys);
		$sms->getCredits($available);

		return $available;
	}

	function sendMessage($title, $message){
		global	$sys;
		
		$warnings = "";

		if($sys->smsSend){
			if(! $this->sys->login->checkLogin("smsSend"))
				return "You are not authorised to send SMS text messages";

			$sms = new BSms($this->sys);

			$numbers = array();

			$message = $title . "\n" . htmlToText($message);
			$objList = $sys->db->getObjectList("User", "telephoneMobile", "`telephoneMobile` != ''", "");
			foreach($objList as $obj){
				$l = explode(",", $obj->telephoneMobile);
				foreach($l as $m){
					$m = $sms->numberClean($m);
					if(strlen($m) == 11)
						$numbers[] = $m;
					else
						$warnings .= "<br>Warning number {$m} is incorrect, ignored.\n";
				}
			}

			if(0){			
				print "Numbers: "; print_r($numbers);
				print "Message: "; print $message;
				return;
			}
			
			// Debug test
			if($this->testNumber != "")
				$numbers = array($this->testNumber);

			$obj = $this->sys->db->getNewObject("Sms");
			$obj->dateAdded = strftime("%Y-%m-%d");
			$obj->user = $this->sys->login->name;
			$obj->number = count($numbers);
			$obj->price = $obj->number * $sys->smsCost;
			$obj->title = $title;;
			$obj->message = $message;

			$this->sys->db->appendObject("Sms", $obj);

			$sms = new BSms($this->sys);
			$r = $sms->sendMessage($sys->siteName, $numbers, $message);
			
//			print "Result: $r";
			if(is_numeric($r)){
				if($r == 0)
					return "Text message has been sent. " . $warnings;
				else
					return "Eroor:" . $warnings;
			}
			else {
				return $r . $warnings;
			}
		}
		return "SMS text messaging is not enabled.";
	}
};


if(0){
	$sms = new BSms();

	$r = $sms->getCredits($n);

	print "NumCredits: Res: {$r} Num: {$n}\n";

	$r = $sms->sendMessage("Beam", array("07980502014"), "This is a test message");

	print "Send: Res: {$r}\n";
}

?>
