<?php
/*******************************************************************************
 *	TandemClub.php	TandemClub Module
 *			T.Barnaby,	BEAM Ltd,	2012-06-08
 *******************************************************************************
 */
require_once "BModule.php";
require_once "BBlock.php";
require_once "BView.php";
require_once "BDate.php";
require_once "BEdit.php";
require_once "BDate.php";

global	$sys;

class TandemClub extends BModule {
	// Basic Interface routines
	function __construct(&$sys){
		parent::__construct($sys);
		$this->name = "tandemClub";
		$this->title = "TandemClub";
		$this->info = "TandemClub module. This module allows the management of TandemClub.";
		
		// Sets up a few things
		$module = $this->sys->modules["groups"]->title = "Regional Groups";
	}

	function checkAccess(){
		return $this->sys->login->checkLogin("admin");
	}

	function getMenu(){
		return Null;
	}

	function getPage($uri){
		$this->parseUri($uri);	
		
		$page = "Tandem Club";
		
		if($this->checkAccess()){
			switch($this->cmd){
			case "groupInit":	$page = $this->groupInit($uri); 	break;
			default:							break;
			}
		}
		return $page;
	}

	function getPageBlock($uri){
		return Null;
	}
	
	function groupInit($uri){
		$groupList = categoryGetList("TcGroups");
		
		$page = implode('","', $groupList);
		
		return $page;
	}

	function groups(){	
		$groups = array("Birmingham","Derbyshire","East London, South & West Essex","East Solent & IOW","Exeter & Taunton","Greater Manchester","Herts","Highland","Hull","Kent","Kidderminster","LA","Leicester Charnwood","Milton Keynes","Norfolk","North East","North East Essex & South Suffolk","North Wales","North West","North Yorkshire","Nottingham","Oxfordshire","Plymouth and Torbay","Sheffield","South East London","South of Scotland","South Staffs","South West","Staffs and Telford","South Staffs","Suffolk","Surrey & Sussex","Teeside","Telford","Thameswey","Three Counties","Welsh Marches","Wessex","West Country","West Yorkshire");
	}
};

?>
